/*
 * JDLC1.java
 *
 * Template Created on September 17, 2007, 3:52 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package Exercises;


/**A template for students to use to demonstrate their knowledge of bit stuffing.
 *The user inputs an email message string through
 *the Standard IO.  The class calculates the bit-packed string, and then
 *it unpacks the same string, to demonstration the restoration of
 *the original string.
 *<p>The output is written to the Standard IO.
 * *<li><b>Version 1.101</b> of 20080305 added lines to method main so that the
 * student would only have to prob=vide methods stuff and unstuff. Decide to direct all
 * output to the standard IO since there is a problem with JTextPane.append()</li>
 * @see <a href="http://en.wikipedia.org/wiki/Bit_stuffing">Bit Stuffing Explanation</a>
 * @see <a href="http://candle.ctit.utwente.nl/wp5/tel-sys/powerpoint/tsa05.ppt#329,12,Framing: Start/End Flag Byte">Bit Stuffing Explanation</a>
 * @version 1.200
 * @author dixonw*/
public class JDLC1 implements GUIConstants.General
{  /**The input data bits*/
   static Utility.JNWBitSet unstuffedDataBitsIn = new Utility.JNWBitSet ( )  ;
   
   /**The bit stuffed result*/
   static Utility.JNWBitSet bitstuffedResult = new Utility.JNWBitSet ( )  ;
   
   /**The input string.*/
   static String inputString =  EMPTY_STRING ; 
   
   /** Creates a new instance of Bit Packing  */
   public JDLC1 ()
   {
   }  // end of JDLC1 constructor
   
   
   /**Runs the bit stuffing.*/
   public static void main ( String [ ] args )
   {  // Read input data
      String inputString =  ReadSingleLineFromStandardIO ( ) ;
      // Convert input data to a qJNWBitSet
      unstuffedDataBitsIn . setJNWBitSetToString ( inputString ) ;
 
      // print input
      System.out.println ("\nYour original email message is :" + inputString
         + "\nwhich gives the bit set:\n" + unstuffedDataBitsIn . toString ( ) );
      
      // STUDENT STUFFS BITSET WITH CALL TO METHOD StuffBitSet
      bitstuffedResult = StuffBitSet ( unstuffedDataBitsIn ) ;;
      // print results
      System.out.println ("\nYour stuffed bit set is:\n"
         + bitstuffedResult . toString ( ) );

      // APPEND A HEADER AND TRAILER
      Utility.JNWBitSet header = new  Utility.JNWBitSet ( "01111110" ) ;
      Utility.JNWBitSet trailer = header ;
      // Add the headera nd trailer
      bitstuffedResult . prepend ( header ) ;
      bitstuffedResult . append ( trailer ) ;
      
      String string =  bitstuffedResult . toString ( ) ;
      System.out.println ("\nYour stuffed bit set with header and trailer are:"
         + bitstuffedResult . toString ( ));
      
      // NOW UNSTUFF THE DATA
      // NOW UNSTUFF THE DATA
      
      System.out.println ("\n\nNOW UNSTUFF DATA") ;
      
      // STUDENT REMOVES THE HEADER by resetting the JNWLength
      bitstuffedResult . setJNWLength ( bitstuffedResult . getJNWLength () - 8 ) ;
      // STUDENT REMOVES THE TRAILER by shifting right 8 bits
      bitstuffedResult. shift ( -8 ) ;
      
      // STUDENT UNSTUFFS BITSET WITH CALL TO METHOD UnstuffBitSet
      unstuffedDataBitsIn = UnstuffBitSet ( bitstuffedResult ) ;
      System.out.println ("\n\nYour unstuffed bit set is:  "
         + unstuffedDataBitsIn . toString ( ) ) ;
      System.out.print ("\n\nYour original email message is:  "
         + unstuffedDataBitsIn . convertJNWBitSetToString ( ) 
         + "\n\n\n"
         + "You ") ;
      if ( unstuffedDataBitsIn . convertJNWBitSetToString ( ) 
      . equals ( inputString )) {
         System.out.println ( "correctly solved the problem: The input "
            + "and output agree.") ;
      }
      else { 
         System.out.println ( "incorrectly solved the problem: "
            + "The input and output do not agree.") ;
      }
      System.out.println ("\n\n\n\n") ;
   }  // end of main
   
   
   /**Reads a single line from standard input*/
   private static String ReadSingleLineFromStandardIO ( )
   {
      // print explanation
      System.out.println ("\nEnter the email message that you wished "
         + "stuffed in StandardIO:\n");
      // obtain input data
      String inputString = null ;
      try
      {
         java.io.BufferedReader bufferedReader = new
            java.io.BufferedReader ( new java.io.InputStreamReader (
            System .in ) ) ;
         inputString = bufferedReader . readLine ( ) ;
      }
      catch ( Exception e )
      {
         System.err.println ( " ERROR IN Demonstrations.BitPacking:"
            + "\nException "+ e. getClass ( ) . getName ( ) + " thrown while tr"
            + "ying to  read line \"" + inputString + "\" in input") ;
      } // end of catch
      return inputString ;
   }  // end of ReadSingleLineFromStandardIO
   
   
   /**Stuffs a string of bits*/
   public static Utility.JNWBitSet StuffBitSet ( Utility.JNWBitSet unstuffedBits )
   {
     Utility.JNWBitSet resultBits = new Utility.JNWBitSet(unstuffedBits);

// Scan the data bits from left to right for length minus sixteen,
// {
//   copy from input to output,
//   {
//     maintain an index, starting at 8, in the input bit array;
//     another index, starting at 8, in the output array;
//     and a counter, starting at zero;
//     when copying a bit,
//     {
//       move the input bit to output;
//       if it is a zero bit, set the counter to zero;
//       if it is a one bit, add one to the counter;
//       if the counter value is five,
//       {
//         insert a zero in the output;
//         zero the counter;
//         add one to the output index;
//       }
//       add one to input index;
//       add one to output index;
//     }
//   }
// }


     return resultBits;

   }  // end StuffBitSet()
   
   
   
   /**Unstuffs a string of bits*/
   public static Utility.JNWBitSet UnstuffBitSet ( Utility.JNWBitSet stuffedBits )
   {
       Utility.JNWBitSet resultBits = new Utility.JNWBitSet(stuffedBits);

// Left as an exercise for the student (it is very much like stuffing)
//
// NOTE: this version only copies the frame, student must change to
// add stuffing


       return resultBits;

   }  // end StuffBitSet()
   
   
}  // end class BitStuffing
