/*
 * JDLC2.java
 *
 * Created on September 17, 2007, 3:52 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package Exercises;


/**A template for students to use to demonstrate their knowledge
 * of FCS computation.  The user inputs a email message string through
 * the Standard IO.  The class calculates the bit-packed string, and then
 * it computes the CRC, then it appends the CRC to the data bit set.
 *
 * @see <a href="http://candle.ctit.utwente.nl/wp5/tel-sys/powerpoint/tsa05.ppt#346,23,Cyclic Redundancy Code - CRC">Demonstration</a>
 * @author dixonw
 * @version 1.200
 */
public class JDLC2 
{
   /**The generator polynomial*/
   static Utility.JNWBitSet FCSGeneratorPolynomial
      = new  Utility.JNWBitSet ( " 1 00010000 00100001 " ) ;
   
   /**The input data bits*/
   static Utility.JNWBitSet dataBitsIn = null  ;
   
   /**A copy of the data bits.*/
   static Utility.JNWBitSet dataBitsCopy = null  ;
   
   /**The FCSPolynomial
    */
   static Utility.JNWBitSet FCSPolynomial = null ;
   
   /**The FCSPolynomial result
    */
   static Utility.JNWBitSet CRCPolynomialResult = null ;
   
   /**The shift register for computing the FCSPolynomial result.
    * The initial length should be as long as the generator polynomial.*/
   static Utility . JNWBitSet shiftRegister
      = new Utility . JNWBitSet (   FCSGeneratorPolynomial .getJNWLength ( )  ) ;
   
   /**Creates a new instance JDLC2.*/
   public JDLC2 ()
   {
   }  // end of public JDLC2 ()
   
   
   /**Runs the FCS computation.*/
   public static void main ( String [ ] args )
   {
      System.out.println ( "\nFCSPolynomial-FCS Generator Example for Network "
         +  "Workbench\n\nEnter characters; this program will append "
         +  ( FCSGeneratorPolynomial.getJNWLength ( ) - 1 ) 
         + " trailing zeros\n"
         +  "and print the resulting bits.\n"
         +  "\nThis program will then calculate the "
         +  ( FCSGeneratorPolynomial.getJNWLength ( ) - 1 ) 
         + "-bit FCS, using\n"
         +  "HDLC protocol specification as defined in Bertsakis & Gallagher,\n"
         +  "Data Networks, 2nd Ed., and print that FCS in binary.\n"
         +  "\nEnter the characters:" );
      
      // read the input String
      String inputString = ReadSingleLineFromStandardIO ( )  ;
      dataBitsIn = new Utility.JNWBitSet ( ) ;
      
      // STUDENT CONVERTS THE STRING TO A BITSET dataBitsIn
      dataBitsIn . setJNWBitSetToString ( inputString ) ;
      // Make a copy
      dataBitsCopy = dataBitsIn . clone ( ) ;
      // Add zeros after characters
      // The number of zeros should be one less 
      // than the length of the generator polynomial
      dataBitsIn . append ( new Utility.JNWBitSet ( 
         FCSGeneratorPolynomial . getJNWLength ( ) - 1 ) );
      // STUDENT CALLS METHOD computeCRC to compute CRC
      FCSPolynomial = computeFCS ( dataBitsIn ) ;
      // STUDENT APPENDS CRC TO dataBitsIn
      dataBitsCopy . append ( FCSPolynomial ) ;
      System.out.println ("\nYour message including the FCSPolynomial\nin binary "
         + "is now:\n" + dataBitsCopy . toString ( ) + "\n" );
      
   }  // end of main
   
   
   /**Reads a single line from standard input*/
   private static String ReadSingleLineFromStandardIO ( )
   {  // print explanation
      // obtain input data
      String inputString = null ;
      try
      {
         java.io.BufferedReader bufferedReader = new
            java.io.BufferedReader ( new java.io.InputStreamReader (
            System . in ) ) ;
         inputString = bufferedReader . readLine ( ) ;
      }
      catch ( Exception e )
      {
         System.err.println ( " ERROR IN Demonstrations.BitPacking:"
            + "\nException "+ e. getClass ( ) . getName ( ) + " thrown while"
            + " trying to  read line \"" + inputString + "\" in input") ;
      } // end of catch
      return inputString ;
   }  // end of ReadSingleLineFromStandardIO
   
   
   /**Computes the CRC for the bit set dataBitSet using the generator polynomial
    *FCSGeneratorPolynomial.*/
   private static Utility.JNWBitSet computeFCS ( Utility.JNWBitSet dataBitSetInput )
   {
      System.out.println ("\nWith "
         + ( FCSGeneratorPolynomial.getJNWLength ( ) - 1 ) 
         + " trailing zero bits, your input\nin binary is:\n"
         + dataBitSetInput . toString ( ) + "\n" );
      System.out.println ("(Here we ignore the 01111110 flags at the "
         + "beginning and end of\nframe, because "
         + "they do not participate in FCS calculation.)\n");
      System.out.println ("The HDLC FCS is calculated from this by:\n\n"
         +  "(1) Shifting the bits into the FCS register,\n"
         +  "    starting with MSB of the input" ) ;
      System.out.println ( "\n(2) shifting until all bits have been through\n"
         +  "    FCS register (last 16 bits shifted in are zeros);\n"
         +  "    each bit shifted out from MSB of FCS register becomes\n"
         +  "    the feedback bit, which is XORed with bits 0, 5 and \n"
         +  "    12 of CRCPolynomial register.\n" );
      System.out.println ("Stepping through the process, the stages of shifting "
         + "look like this:\n\n" ) ;
      
//// STUDENT SHOULD ENTER STEPS HERE  
//// STUDENT SHOULD ENTER STEPS HERE  
//// STUDENT SHOULD ENTER STEPS HERE  
//// STUDENT SHOULD ENTER STEPS HERE      
      
// NW DLC CRC Algorithm
// --------------------
// establish an array FCS with 16 positions;
// do for each data bit (but not for the start and end flags),
// scanning the frame from left to right,
// {
//   make a copy of the high order FCS bit, call it "feedback";
//   shift each FCS bit to the next higher FCS order bit;
//   shift one data bit into the low-order bit of the FCS;
//   as bits 0, 5 and 12 are shifted,
//     XOR them with the feedback bit;
// }
//
//  student inserts CRC calculation here
//  STUDENTS REPLACE THE RETURN STATEMENT BELOW TO RETURN THE CRCed RESULT      
      return dataBitSetInput   ;
   }  // end of computeFCS
   
   
}  // end of class JDLC2
