/* Generated by Together */
package GUIActions;

import javax.swing.*;
import GUIs.StandardJFrame;

/**An abstract base class used by all the actions of the Main GUI.  Its
 *  main purpose is to assign names, icons, etc. to the Action.
 * Gets the global variables of the model.
 * @version 1.100
 * @author dixonw*/
public abstract class MainGUIActionsBaseClass
   extends AbstractAction implements GUIConstants.General {

   /**Creates a reference to the StandardJFrame so the cursor can be changed.*/
   StandardJFrame standardJFrame = new StandardJFrame ();

   /**The file used by the JFileChooser in any of the classes
    * that use a JFileChooser.  The JFileChooser will reopen in the
    * same folder that it closed.*/
   static java.io.File fileNameForJFileChooser = null;

   /**Creates an instance that points to the singleton input data*/
   GUIData.InputDataSingleton inputData =
      GUIData.InputDataSingleton.getInstance ();

   /**The jTextPane for output.*/
   protected GUIData.JNWSingletonJTextPane jTextPane =
      GUIData.JNWSingletonJTextPane.getInstance ();

   public MainGUIActionsBaseClass () {
   }


   /**The constructor in each subclass calls AssignToAction ( ) to add the
    * accelerator key, the long description, the short description, the
    * mnemonic key, and the small icon to the action.*/
   protected void AssignToAction (
      String acceleratorKey , String longDescription , char mnemonicKey ,
      String actionName , String shortDescription , String iconName ) {
      // set Action long description
      this.putValue ( Action.LONG_DESCRIPTION , longDescription );
      // set Action mnemonic key
      this.putValue ( Action.MNEMONIC_KEY , new Integer ( mnemonicKey ) );
      // set Action nam
      this.putValue ( Action.NAME , actionName );
      // set Action short description (tooltip text)
      this.putValue ( Action.SHORT_DESCRIPTION , shortDescription );
      // Ensure the icon name is not null
      // set the Action icon
      this.putValue ( Action.SMALL_ICON , new ImageIcon (
         this.getClass ().getResource ( "/GUIs/GUIIcons/" + iconName ) ) );
   }  // end of AssignToAction

}  // end of class