/* Generated by Together */
package GUIActions;

import java.awt.event.ActionEvent;
import javax.swing.*;

/**Writes the text contained in the center panel of the Main GUI as a
 * text file to the location and file name of the users choice.
 *<p><b>Versions:</b>
 *<li><b>Version 1.200</b> of 20081106 adds a switch statement to
 * topologyToString so that Ethernet buses can be written correctly.</li>
 * * @version 1.200
 * @author dixonw*/
public final class WriteTopologyFileAsTextAction extends MainGUIActionsBaseClass
   implements GUIConstants.General {

   /**Access to the Links.*/
   private ModelData.JNWSingletonVectorOfLinks vectorOfLinks =
      ModelData.JNWSingletonVectorOfLinks.getInstance ();

   /**Access to the Nodes.*/
   private ModelData.JNWSingletonVectorOfNodes vectorOfNodes =
      ModelData.JNWSingletonVectorOfNodes.getInstance ();

   /**A file chooser.*/
   private JFileChooser jFileChooser = null;

   /**The output file.*/
   private java.io.File outputFile;

   /**A file writer.*/
   private java.io.FileWriter fileWriter;

   /** Constructor calls AssignToAction ( ) to add the
    * accelerator key, the long description, the short description, the
    * mnemonic key, and the small icon to the action.*/
   public WriteTopologyFileAsTextAction () {
      // Call CompleteAction to add all the attributes to the action
      AssignToAction (
         WriteTopologyAsTextAction_ACCELERATOR_KEY ,
         WriteTopologyAsTextAction_LONG_DESCRIPTION ,
         WriteTopologyAsTextAction_MNEMONIC_KEY , WriteTopologyAsTextAction_NAME ,
         WriteTopologyAsTextAction_SHORT_DESCRIPTION ,
         WriteTopologyAsTextAction_SMALL_ICON );
   }  // end of public WriteTopologyFileAsTextAction()


   /** Performs the action when the toolbar button is clicked on the menubar
    * entry is clicked.*/
   public void actionPerformed ( ActionEvent event ) {
      jFileChooser = new JFileChooser ( fileNameForJFileChooser );
      //Handle open button action.
      jFileChooser.setDialogTitle ( "WRITE NETWORK TOPOLOGY TO TEXT FILE" );
      int returnVal = jFileChooser.showSaveDialog ( null );
      if (returnVal == JFileChooser.APPROVE_OPTION) {
         outputFile = jFileChooser.getSelectedFile ();
         // update the fileNameForJFileChooser for later access to the same
         // folder
         fileNameForJFileChooser = jFileChooser.getSelectedFile ();
         //Open the TreeModel and save the serialized file.
         try {
            // open object file for reading
            fileWriter = new java.io.FileWriter ( outputFile );
            // Should be the same as in CopyInputToOutputAction
            fileWriter.write ( topologyToString () );
            fileWriter.flush ();
            fileWriter.close ();
         }
         catch ( java.lang.Exception exception ) {
            Utility.err.println ( "ERROR IN SaveAsJavaFileAction Exception " 
               + exception.getClass (). getName () + " thrown while writing " 
               + "input date" );
            exception.printStackTrace ();
         }  // end of try-catch
      }// end of if (returnVal == JFileChooser.APPROVE_OPTION)
   }  // end of public void actionPerformed(ActionEvent event)


   /**Creates the String describing the topology.*/
   private String topologyToString () {
      java.lang.StringBuilder stringBuilder =
         new java.lang.StringBuilder ( 1000 );
      stringBuilder.append (
         "// JAVA NETWORK WORKBENCH NETWORK TOPOLOGY INPUT FILE" +
         DOUBLE_CARRIAGE_RETURN + "// Network type is " + CARRIAGE_RETURN +
         GUIActions.ReadTopologyFileAction.networkTypePrefix + SPACE +
         ModelData.GlobalVariables.networkType.toString () +
         DOUBLE_CARRIAGE_RETURN + "// MANDATORY LINK CHARACTERISTICS" +
         CARRIAGE_RETURN +
         "// LINK FORMAT: SOURCE NODE NUMBER, DESTINATION NODE NUMBER, " +
         "CAPACITY IN KBPS," + CARRIAGE_RETURN +
         "// INTERFACE TYPE, BIT ERROR RATE, TRANSMISSION" +
         " DELAY IN MICROSECONDS" + CARRIAGE_RETURN );
      switch ( ModelData.GlobalVariables.networkType ) {
         case Router_Network:
            for ( int i = 0 ; i < vectorOfLinks.size () ; i ++ ) {
               ModelPhysical.Link link = ( ModelPhysical.Link ) vectorOfLinks.
                  get ( i );
               stringBuilder.append ( link.sourceNodeNumber + COMMA +
                  link.destinationNodeNumber + COMMA +
                  link.bitRateSourceToDestination + COMMA + link.interfaceType.
                  toString () + COMMA + link.bitErrorRate + COMMA +
                  link.transmissionDelay + CARRIAGE_RETURN );
            }  // end of for ( int i = 0 ; i < vectorOfLinks . size ( ) ; i++ )
            break;
         case Ethernet_Bus:
            // Get Link ( 0 ) 
            ModelPhysical.EthernetBus ethernetBus =
               ( ModelPhysical.EthernetBus ) vectorOfLinks.get ( 0 );
//// System.out.println ("IN WriteTOpology..action: transmissionDelay array is" +
////    ethernetBus .transmissionDelay . length + " by " + ethernetBus .transmissionDelay [0]. length) ;              
////  System.out.println ("IN WriteTOpology..action: vectorOfNodes . size ( ) = " +
////  vectorOfNodes . size ( ) ) ;
            // Remember that for an Ethernet bus the number of 
            // Links is vectorOfNodes . size ( ) - 1
            for ( int i = 0 ; i < vectorOfNodes.size () - 1 ; i ++ ) {
               stringBuilder.append ( i + COMMA + ( i + 1 ) + COMMA +
                  ethernetBus.bitRateEthernetBus + COMMA +
                  ethernetBus.interfaceType.toString () + COMMA +
                  ethernetBus.bitErrorRate + COMMA +
                  ethernetBus.transmissionDelay[i][i + 1] + CARRIAGE_RETURN );
            }  // end of for ( int i = 0 ; i < vectorOfLinks . size ( ) ; i++ )
            break;
         case Token_Ring:
            Utility.err.println ( "ERROR IN WriteTopologyFileAsTextAction" +
               ".topologyToString: Token Ring not implemented yet." );
            break ; 
         case Undefined:
            Utility.err.println ( "ERROR IN WriteTopologyFileAsTextAction" +
               ".topologyToString: Network type Undefined." );
            break ; 
      }  // end of switch        
      stringBuilder.append ( CARRIAGE_RETURN + "// OPTIONAL NODE POSITIONS" +
         CARRIAGE_RETURN + "// IF NOT READ-IN HERE, THE POSITIONS ARE " +
         "RANDOMLY ASSIGNED BY THE MODEL" + CARRIAGE_RETURN );
      for ( int i = 0 ; i < vectorOfNodes.size () ; i ++ ) {
         ModelPhysical.Node node =
            ( ModelPhysical.Node ) vectorOfNodes.get ( i );
         stringBuilder.append (
            GUIActions.ReadTopologyFileAction.nodePositionPrefix + SPACE + i +
            SPACE + EQUALS + SPACE + LEFT_PARENTHESIS + SPACE + node.XPos +
            SPACE + COMMA + SPACE + node.YPos + SPACE + RIGHT_PARENTHESIS +
            CARRIAGE_RETURN );
      }  // end of for ( int i = 0 ; i < vectorOfLinks . size ( ) ; i++ )
      return new String ( stringBuilder );
   }  // end of private String topologyToString ( )


}  // end of class
