/*
 * General.java
 *
 * Created on December 20, 2006, 3:12 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package GUIConstants;

/**Defines the constants for the simulation.  General is the root
 * of a tree of interfaces defining the constants used throughout the
 * simulation.
 * *<p><b>Versions:</b>
 * <li><b>Version 1.001</b> of 20080616 adds TWO_TO_THE_32.</li>
 * @version 1.101
 * @author dixonw*/
public interface General extends ColorsForGUIs, ConstantsForGUIs,
   FontsForGUIs, /*DecimalFormatsUnused, */JFrameConstants, MainGUIActionsConstants,
   MainGUIMenuBarConstants, TopologyInput {

     /**A constant used to define the look and feel of the GUIs
    * The look and feel is implemented in class StandardJFrame.</P>
    * <P>The LOOK_AND_FEEL_CONSTANT chooses the look and feel of all the GUIs
    * <ul>
    * <li>set LOOK_AND_FEEL_CONSTANT = 0 for "Metal"
    * <li>set LOOK_AND_FEEL_CONSTANT = 1 for "Openlook"
    * <li>set LOOK_AND_FEEL_CONSTANT = 2 for "Windows"</LISTING></P>
    * </ul>*/
    int LOOK_AND_FEEL_CONSTANT = 0 ;

    /**Carriage return used to spacing output.*/
    String CARRIAGE_RETURN = "\n" ;

    /**Carriage return used to spacing output.*/
    String DOUBLE_CARRIAGE_RETURN = "\n\n" ;

    /**Equals sign.*/
    String EQUALS = "=" ;

    /**Left parenthesis.*/
    String LEFT_PARENTHESIS = "(" ;

    /**Right parenthesis.*/
    String RIGHT_PARENTHESIS = ")" ;

    /** A null string used for initialization to ensure that Strings
     * are not initialized to "null".*/
    String EMPTY_STRING = "";

    /**A comma.*/
    String COMMA = "," ;

     /**A SPACE*/
    String SPACE = " " ;

    /**A TAB.*/
    String TAB = "\t" ;

    /**Minus one*/
    int MINUS_ONE = -1 ;

    /**Zero*/
    int ZERO = 0 ;

    /**Floating point 0.0.*/
    float ZERO_FLOAT = ( float )  0.0 ;

    /**A large floating point number*/
    float HUGEFLOAT = Float.MAX_VALUE ;

    /**2**32.  Used in modulo 2**32 arithmetic for the TCP
     sequence numbers.*/
    long TWO_TO_THE_32 = 1024 * 1024 * 1024 * 4 ;

    /** Decimal format for printing floating point numbers.  Format is X.XXXX.*/
    java.text.DecimalFormat decimalFormatFourDigits
       = new java.text.DecimalFormat ( "0.0000" ) ;

}  // end of interface
