/*
 * Global_Variables.java
 *
 * Created on June 2, 2007, 9:11 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */
package GUIData;

import Utility.JNWRandom;

/**A class of common variables used throughout the model.
 *<li><b>Version 1.101</b> of 20080128 read the networkType from the
 * topology file rather than input from the Globle variables GUI.</li>
 *<li><b>Version 1.200</b> of 20081027 added pause_at_prints and 
 * interactive_operation to the class.</li> 
 *<li><b>Version 1.201</b> of 20081029 moved random_number_generator_seed
 * from last to third field in class.</li>
 *<li><b>Version 1.202</b> of 20111027 added HDLC.</li>
 * @version 1.202
 * @author dixonw
   @modified JMP to fix multiple bugs and add HDLC*/
public class Global_Variables extends InputClassesBaseClass
   implements java.io.Serializable {

   /**Author(s) name(s)*/
   public static GUIData.JNWJTextArea authors_names = new GUIData.JNWJTextArea (
      ModelData.GlobalVariables.authorsNames );

   /**Maximum time ticks*/
   public static GUIData.JNWLongInteger maximum_DES_Ticks = new GUIData.JNWLongInteger (
      ModelData.GlobalVariables.maximumDESTicks );

   /**This is the seed for the random number generator of class JNWRandom.*/
   public static GUIData.JNWLongInteger random_number_generator_seed = new GUIData.JNWLongInteger (
      JNWRandom.getInstance ().seedForJNWRandomNumberGenerator );
   
   /**Boolean that tells whether error messages will be displayed on
    * the MainGUI.*/
   public static GUIData.JNWBoolean print_errors_on_MainGUI =
      new GUIData.JNWBoolean ( Utility.err.sendErrorsToMainGUI );

   /**Boolean that tells whether warning messages will be displayed on
    * the MainGUI.*/
   public static GUIData.JNWBoolean print_warnings_on_MainGUI =
      new GUIData.JNWBoolean ( Utility.war.sendWarningsToMainGUI );

   /**Boolean that tells whether error messages will be displayed on
    * the MainGUI.*/
   public static GUIData.JNWBoolean verify_checksums_at_receiver =
      new GUIData.JNWBoolean (
      ModelData.GlobalVariables.verifyChecksumsAtReceiver );

  /**Boolean that tells whether error messages will be displayed on
    * the MainGUI.*/
   public static GUIData.JNWBoolean print_receiver_errors =
      new GUIData.JNWBoolean ( ModelData.GlobalVariables.printReceiverErrors );
   
   /**Boolean that tells whether to pause after each print statement.*/
   public static GUIData.JNWBoolean pause_at_prints =
      new GUIData.JNWBoolean ( ModelData.GlobalVariables.interactiveModeOfOperation );
   
   /**Boolean that tells whether error messages will be displayed on
    * the MainGUI.*/
   public static GUIData.JNWBoolean interactive_operation =
      new GUIData.JNWBoolean ( ModelData.GlobalVariables.interactiveModeOfOperation );

   /** Creates a new instance of Global_Variables */
   public Global_Variables () {
   } // end of public Global_Variables ()

   /** Sets the appropriate variables to the input data.  This also sets the seed
    * of the random number generator from GUI data.    THIS METHOD IS 
   CALLED BY REFLECTION.*/
   public static void UpdateInputData () {
      ModelData.GlobalVariables.authorsNames = authors_names.getString ();
      ModelData.GlobalVariables.maximumDESTicks 
         = maximum_DES_Ticks. getLongInteger ();
      Utility.err.sendErrorsToMainGUI = print_errors_on_MainGUI . getBoolean ();
      Utility.err.sendErrorsToMainGUI = print_errors_on_MainGUI . getBoolean ();
      ModelData.GlobalVariables.verifyChecksumsAtReceiver 
         = verify_checksums_at_receiver . getBoolean ();
      ModelData.GlobalVariables.printReceiverErrors 
         = print_receiver_errors. getBoolean ();
      ModelData.GlobalVariables.interactiveModeOfOperation 
         = interactive_operation . getBoolean () ;
      ModelData.GlobalVariables.pauseAtPrints 
         = pause_at_prints . getBoolean () ;
      
      // If the checksum is not calculated, then make sure it is not printed.
      if (verify_checksums_at_receiver . getBoolean () == false) {
         ModelData.GlobalVariables.printReceiverErrors = false;
         print_receiver_errors.setBoolean ( false );
      }  // end of if ( verify_checksums_at_receiver . getBoolean ( ) == false )
      // Set the seed in the random number generator
      JNWRandom.getInstance ().seedForJNWRandomNumberGenerator =
         random_number_generator_seed.getLongInteger ();
   }

}
