package GUIData;


/*
 * InputDataSingleton.java
 *
 * Created on January 15, 2007, 8:20 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */
/** InputDataSingleton is a singleton wrapper for all the data needed
 * for input. It only provides a holding place for the input data.
 *
 * @version 1.100
 * @author dixonw*/
public class InputDataSingleton implements java.io.Serializable ,
   GUIConstants.General {

   /**Global variables*/
   public GUIData.Global_Variables global_Variables =
      new GUIData.Global_Variables ();

   /**Print permissions*/
   public GUIData.Print_Permissions print_Permissions =
      new GUIData.Print_Permissions ();

   /**Variable for the message load generator.*/
   public GUIData.Load_Generator_Variables load_Generator_Variables =
      new GUIData.Load_Generator_Variables ();

   /**A singleton vector containing all the Nodes.*/
   public ModelData.JNWSingletonVectorOfNodes<ModelPhysical.Node> vectorOfNodes =
      ModelData.JNWSingletonVectorOfNodes.getInstance ();

   /**A singleton vector containing all the Links.*/
   public ModelData.JNWSingletonVectorOfLinks<ModelPhysical.Link> vectorOfLinks =
      ModelData.JNWSingletonVectorOfLinks.getInstance ();

   /**A singleton vector containing all the Interfaces*/
   public ModelData.JNWSingletonVectorOfInterfaces<ModelDataLink.InterfaceBaseClass> vectorOfInterfaces =
      ModelData.JNWSingletonVectorOfInterfaces.getInstance ();

   /**Spare action.*/
   public GUIData.Spare_Action_GUI spare_Action =
      new GUIData.Spare_Action_GUI ();

   /**The singleton instance of the class InputDataSingleton. <b><u>DO NOT MOVE</u></b>
    * the location of this field in the class.  It MUST be the last field in this class.
    * It will destroy the toSting() method and cause the model to go into an
    * infinite loop.*/
   private static final InputDataSingleton inputData = new InputDataSingleton ();

   /**Creates a new instance of InputDataSingleton.*/
   private InputDataSingleton () {
   }  // end of private InputDataSingleton ( )

   /**Method to return instance of the InputDataSingleton.*/
   public static InputDataSingleton getInstance () {
      return inputData;
   }  // end of public static InputDataSingleton getInstance ( )

   /**Returns a String containing all the input data. <b>IMPORTANT:</b> Note
    * the last field to be printed is inputDataFields . length -2 since
    * the inputDataFields . length -1 field is the singleton of this
    * class itself and you will enter an endless loop.  You <b>CANNOT </b>
    * try to convert all the field of this singlteon to a String.  If the
    * toString method includes the singleton, the mnethod will go
    * into an endless loop.*/
   public String toString () {
      java.lang.StringBuilder stringBuilder =
         new java.lang.StringBuilder ( 3000 );
      // Out date
      stringBuilder.append ( "\nDate:  " + ( new java.util.Date () ).toString () +
         "\nThe input data for Java Network Workbench is:\n" );
      // Get the input Fields
      java.lang.reflect.Field inputDataFields[] = this.getClass ().
         getDeclaredFields ();
      // Get one Field
      // IMPORTANT: Note the last field to be printed is inputDataFields . length -2 since
      // the inputDataFields . length -1 field is the singleton of this class itself
      // and you will enter an endless loop.  You CANNOT try to convert
      // all the field of this singlteon to a String.  If the toString method includes
      // the singleton, the mnethod will go into an endless loop.
      for ( int i = 0 ; i < inputDataFields.length - 1 ; i ++ ) {
         java.lang.Class class2 = null;
         java.lang.reflect.Field inputDataField = null;
         try {
            inputDataField = inputDataFields[i];
            class2 = inputDataField.getDeclaringClass ();
            stringBuilder.append ( "\nField " + GUIs.StringProcessorsforGUIs.
               MakeJFrameTitle ( inputDataField.getName () ) + " with values:" );
            Object fieldInInputData = ( inputDataFields[i].get ( this ) );
            stringBuilder.append ( fieldInInputData.toString () );
         }
         catch ( Throwable throwable ) {
            Utility.err.println ( "ERROR in GUIDatas.InputData.toString ( )" +
               "throws an " + throwable.getClass ().getName () +
               "\nIn getting the " + ( i ) +
               "th attribute of inputData ( named " + inputDataField.getName () +
               " ) " + "\nThe exception message is " + throwable.getMessage () );
         }  // end of catch
         stringBuilder.append ( DOUBLE_CARRIAGE_RETURN );
      }  // end of for
      return new String ( stringBuilder );
   }  // end of public String toString ( )

}  // end of class
