/* Generated by Together */
package GUIData;

/**A wrapper for an enumerated value.  This wrapper includes
 * a method to return a JComponent loaded with the data value
 * and a method to read the data value in the JComponent.  The
 * class throws the DataTypes.ErroneousEntryException if
 * erroneous data is entered.
 * @version 1.100
 * @author dixonw*/
public class JNWJComboBox /*extends java.awt.Component*/
   implements java.io.Serializable , GUIConstants.General {

   /**Object to create the selections in a JComboBox */
   Object[] objects;

   /** The JComboBox holding the string representation of the
    * enumeration*/
   private javax.swing.JComboBox jComboBox;

   /**The enumeration.*/
   public java.lang.Enum enumerationValue;

   /**The enumeration set.*/
   java.util.EnumSet enumerationSet;

   /** The string value of the selected enumeration*/
   String stringRepresentation;

   /** The index of the position of the enumeration in the enumeration set.  The
    * JComboBox uses the index to know which of the enumeration values has
    * been selected.  When the comboBox is opened the indexth value is selected.*/
   int index = 0;

   /**Constructor that initializes the enumeration to the first value in the
    * enumeration.*/
   public JNWJComboBox ( java.util.EnumSet enumSetIn ) {  // Initialize index to 0
      index = 0;
      // Copy the EnumSetIn
      enumerationSet = enumSetIn;
      // Create an Object array containing the enumeration values.
      objects = enumSetIn.toArray ();
   }  // end of constructor

   /**Returns a JComponent, here a JComboBox, loaded with the attribute's present
    * value. */
   public javax.swing.JComponent ReturnLoadedJComponent () {
      // Populate the JComboBox with the enumeration values.
      jComboBox = new javax.swing.JComboBox ( objects );
      // Select the current value of the enumeration
      jComboBox.setSelectedIndex ( index );
      jComboBox.setSelectedItem ( objects[index] );
      // Set the border
      jComboBox.setBorder ( javax.swing.BorderFactory.createLineBorder (
         java.awt.Color.DARK_GRAY ) );
      jComboBox.setMaximumSize (
         new java.awt.Dimension ( maximumJTextFieldWidth ,
         maximumJTextFieldHeight ) );
      return jComboBox;
   }

   /** Reads the value of stringRepresentation from the JTextField.  It reads the index
    * of the enumeration value selected.  It throws a
    *DataTypes.ErroneousEntryException if there is an error in inputting the data.
    *@throws DataTypes.ErroneousEntryException indicating that an error was
    *made in converting the String to a long integer.*/
   public void ReadValueFromGUI () throws GUIData.ErroneousEntryException {
      try {  // Get the index of the enumeration selected
         index = jComboBox.getSelectedIndex ();
      }
      catch ( Exception e ) {
         Utility.err.println ( "EXCEPTION " + e.getClass ().getName () +
            " thrown in JNWComboBox.ReadValueFromGUI() in converting " +
            "\nThe existing value is unchanged." );
         throw new GUIData.ErroneousEntryException ();
      }  // end of catch
   }  // end of ReadValueFromGUI

   /** A getter method for the enumeration.  Unfortunately,
    *the method java.lang.Enum.valueOf appears not to be working
    * in Java 1.5.0.  It is necessary, therefore, to create a
    * java.util.Iterator for the Collection of the enumeration.
    * The method iterates over the enumeration, converting each
    * enumeration value to its String representation.  If the
    * String value of the enumeration selected,
    * objects [ index  ] . toString( ) matches the String
    * value of the enumeration, enumerationValue.toString()
    * then the enumeration is returned.  This method is a MESS!*/
   public java.lang.Enum getValue () {
      stringRepresentation = objects[index].toString ();
      // Convert the index back to the enumeration value.
      java.util.Iterator iterator = enumerationSet.iterator ();
      while (iterator.hasNext ()) {
         enumerationValue = ( java.lang.Enum ) iterator.next ();
         if (enumerationValue.toString ().equals ( stringRepresentation )) {
            return enumerationValue;
         }
      }  // end of while ( iterator . hasNext ())
      Utility.err.println ( "ERROR in GUIDatas.JNWJComboBox.getValue ( ):" +
         " The stringRepresentation does not equal any enumeration value." );
      return null;
   }

   /** A setter method for the enumeration.  This sets the enumeration
   value to the indexth value in the enumation set.*/
   public void setSelection ( java.lang.Enum selection ) {
      stringRepresentation = selection.toString ();
      // Convert the index back to the enumeration value.
      java.util.Iterator iterator = enumerationSet.iterator ();
      int iteratorIndex = -1;
      boolean found = false;
      while (iterator.hasNext ()) {
         enumerationValue = ( java.lang.Enum ) iterator.next ();
         iteratorIndex = iteratorIndex + 1;
         if (enumerationValue.toString ().equals ( stringRepresentation )) {
            index = iteratorIndex;
            found = true;
         }
      }
      if (found == false) {
         Utility.err.println ( "ERROR in GUIDatas.JNWJComboBox.getValue ( ):" +
            " The stringRepresentation does not equal any enumeration value." );
      }  // end of if ( found == false )
   }  // end of

   /** A toString() method.*/
   public String toString () {
      return objects[index].toString ();
   }

}  // end of class JNWJComboBox
