/*
 * Print_Permissions.java
 *
 * Created on January 11, 2007, 10:38 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */
package GUIGraphical;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;

/**Display the network including Nodes, Interfaces, and Links.  Permits
 * the user to view the network as it runs.
 * @version 1.200
 * @author dixonw*/
public class NetworkDisplay_RealTime extends GUIs.StandardJFrame {
////   public class TopologyDisplay extends GraphicalVectors {
   /**A singleton vector containing all the Nodes*/
   private static ModelData.JNWSingletonVectorOfNodes<ModelPhysical.Node> vectorOfNodes =
      ModelData.JNWSingletonVectorOfNodes.getInstance ();

   /**A singleton vector containing all the links*/
   private static ModelData.JNWSingletonVectorOfLinks<ModelPhysical.Link> vectorOfLinks =
      ModelData.JNWSingletonVectorOfLinks.getInstance ();

   /**A singleton vector containing all the interfaces*/
   private static ModelData.JNWSingletonVectorOfInterfaces<ModelDataLink.InterfaceBaseClass> vectorOfInterfaces =
      ModelData.JNWSingletonVectorOfInterfaces.getInstance ();

   /**The random number generator*/
   private static Utility.JNWRandom randomNumberGenerator = Utility.JNWRandom.
      getInstance ();

   /**A node position. The position [0] is the X position, xPos, and
    * position [1] is the Y position, xPos. */
   private static int[] position = new int[ 2 ];

   /**A vector of node positions.  A Node is simply the X and Y coordinates.*/
   public static java.util.Vector<int[]> nodeVector =
      new java.util.Vector ( 20 );

   /**A vector of GUIGraphical.GraphicalLinks. */
   public static java.util.Vector<GUIGraphical.GraphicalLink1> linkVector =
      new java.util.Vector ( 50 );

   /**A vector of node positions.  A Node is simply the X and Y coordinates.*/
   public static java.util.Vector<int[]> interfaceVector =
      new java.util.Vector ( 20 );

   /**The nodeRadius of the Nodes in pixels.  This radius is larger than 
    * in GUIGraphical.TopologyDisplay.*/
   private static int nodeRadius = 40;

   /**The nodeRadius of the Interfaces in pixels.*/
   private static int interfaceRadius = 20;

   /**The node on which the mouse was pressed.  This is the number of the Node
    * on which the mouse is pressed.  This is computed by
    * MouseClickHandler.FindNodeWherePressed ( ) .  If the mouse is not
    * pressed on a Node, the value is MINUS_ONE.*/
   private static int nodeWherePressed;

   /**The node on which the mouse was released.*/
   private static int nodeWhereReleased;

   /**Is dragging taking place? This is set in
    * MouseMotionAdapter.mouseDragged.*/
   private static boolean isDraggingTakingPlace;

   /**Is the right button clicked? */
   private static boolean isRightButtonClicked;
   
   /**A temporary GraphicalLink1.*/
   private static GraphicalLink1 temporaryLink = null;

   /**The X and Y mouse positions.*/
   private static int XPos,  YPos;

   /**The "ENTER/UPDATE" button.*/
   private static javax.swing.JButton closerButton;

   /**The button title.*/
   private static String inputGUIButtonTitle = "CLOSE/UPDATE";

   /**The panel where the network will be drawn.*/
   private static JPanel drawingPanel = new JPanel ();
   
   /**tells whether the network display is currently open.*/
   public static boolean isNetworkDisplayCurrentlyOpen ;

   /**The singleton instance of the class InputDataSingleton. <b><u>DO NOT
    * MOVE</u></b> the location of this field in the class.  It <b><u>MUST
    * </u></b>be the last field in  this class. It will destroy the
    * toSting() method and cause the model to go into an infinite loop.*/
////   private static NetworkDisplay_RealTime networkDisplay = null;
////      new NetworkDisplay_RealTime ();
      private static final NetworkDisplay_RealTime networkDisplay 
        =  new NetworkDisplay_RealTime ();
   /** Creates a new instance of TopologyDisplay */
   private NetworkDisplay_RealTime () {
      super ();

   }  // end of constractor

   

   static {
/*      // The first time through, create the GUI
      if (networkDisplay == null) {
         try {
         javax.swing.SwingUtilities.invokeAndWait (
            new java.lang.Runnable () {
               public void run () {
                  networkDisplay = new NetworkDisplay_RealTime ();
               }
            } );
         } catch ( java.lang.Exception exception )
      {
         Utility.err.println  ( " ERROR IN MainGUI_Actions.ReadTopologyFileAction.actionPerformed:"
            + "\nException "+ exception. getClass ( ) . getName ( ) + " thrown while trying to "
            + "open topology file because " + exception . getCause ( )  ) ;
      }
      }  // end of if ( networkDisplay == null )
 */ 
      // Set the title
      networkDisplay.setTitle ( jFrameBaseTitle + " Network Display" );
      networkDisplay.setSize ( ( int ) 1.8 * mainGUIInitialWidthInPixels ,
         ( int ) 1.8 * mainGUIInitialHeightInPixels );
      networkDisplay.setResizable ( true );
      // Add the listeners in the static initilizer
      // They CANNOT be added in the getInstance () method or you
      // will have multiple listeners.
      // Add a mouse listener to the drawing panel
      networkDisplay.addMouseListener ( new MouseClickHandler () );
      // Add a mouse listener to the drawing panel
      networkDisplay.addMouseMotionListener ( new MouseMotionAdapter () );
      // Define the standard responses to Window Events
      networkDisplay.addComponentListener ( new MyComponentAdapter () );
      // Define the standard responses to Window Events
      networkDisplay.addWindowListener ( new MyGraphicalWindowAdapter () );
      // Add in the JButtons
      ////     buttonPanel = new JPanel ();
      closerButton = new javax.swing.JButton ( inputGUIButtonTitle );
      // make a border for the buttons
      Border border = BorderFactory.createBevelBorder ( BevelBorder.RAISED );
      closerButton.setBackground ( standardBlueButtonColor );
      closerButton.setForeground ( standardButtonLetteringColor );
      closerButton.setFont ( standardButtonBoldFont );
      closerButton.setBorder ( border );
      closerButton.addActionListener ( new java.awt.event.ActionListener () {
         // override the actionPerformed method
         public void actionPerformed ( java.awt.event.ActionEvent e ) {
////            System.err.println ( "Pressed network button." );
            networkDisplay.setVisible ( false );
              // Updates Nodes positions on the Vector of Nodes
            for ( int i = 0 ; i < nodeVector.size () ; i ++ ) {
               // Save the current ( X , Y ) position of the Node
               ModelPhysical.Node node = vectorOfNodes.get ( i );
               position = nodeVector . get ( i );
               node.XPos = position[ 0 ];
               node.YPos = position[ 1 ];
////System.err.println ( "Node " + i + " now has position " +  node.XPos + " , " + node.YPos  );               
            }             
            nodeVector.clear ();
            linkVector.clear ();
            interfaceVector.clear ();
         }  // end of actionPerformed
      } // After adding action listener
         ); // end of closerButton . addActionListener
         isNetworkDisplayCurrentlyOpen = false ;
   }  // end of static initializer

   /**Returns the one instance of an input GUI.  getinstance( ) will delete
    * all the components from the center panels and reconstruct the
    * new center panel.
   <p>NOTE that the NetworkDisplay_RealTime.getInstance () method does NOT set the
   GUI to visible.  That must be a separate method call.  This is necessary
   becasue the GUIWorker calls NetworkDisplay_RealTime.getInstance () in its static
   initializer, but it does NOT want to make the GUI visible until needed.*/
   public static NetworkDisplay_RealTime getInstance () {
      // Initialize the arrays for display and update
      InitializeVectors ();
      // Clear out the old components
      networkDisplay.getContentPane ().removeAll ();
      // Set the default close operation
      networkDisplay.setDefaultCloseOperation (
         javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE );
      // Set the upper left corner of the GUI to a specific location
      networkDisplay.setLocation ( XLocationOfInputGUI , YLocationOfInputGUI );
      // Add in the JButtons
      JPanel buttonPanel = new JPanel ();
      java.awt.GridLayout grid = new java.awt.GridLayout ( 2 , 1 );
      buttonPanel.add ( closerButton );
      networkDisplay.add ( drawingPanel , java.awt.BorderLayout.NORTH );
      networkDisplay.add ( buttonPanel , java.awt.BorderLayout.SOUTH );
      isNetworkDisplayCurrentlyOpen = true ;
      return networkDisplay;
   }  // end of networkDisplay ( )

   
   /** Initializes the arrays of Nodes, Interfaces, and Links from 
    * the input data.  It reads vectorOfNodes, vectorOfLinks, and 
    * vectorOfInterfaces and creates nodeVector, linkVector, 
    * and interfaceVector.*/
   public static void InitializeVectors () {
      if (vectorOfNodes.isEmpty ()) {
////        System.err.println ( "IN AddNodeAndLinks: no nodes" );
         return;
      }
      // Get the maximum X and Y positions that can be displayed
      // in the network display
      java.awt.Dimension displayDimension = networkDisplay.getSize ( ) ;
      // Add Nodes
      for ( int i = 0 ; i < vectorOfNodes.size () ; i ++ ) {
         ModelPhysical.Node node = vectorOfNodes.get ( i );
         XPos = node.getXPos ();
         YPos = node.getYPos ();
         // If the point is outside the display window assign the node
         // a random position   
         if ( XPos < 0 | YPos < 0 /*| XPos > displayDimension . height
            | YPos > displayDimension . width*/ ) {
            XPos 
               = randomNumberGenerator.nextInt ( mainGUIInitialWidthInPixels );
            YPos 
               = randomNumberGenerator.nextInt ( mainGUIInitialHeightInPixels );
            node.setPosition ( XPos , YPos );
         }  // end of if
         position[ 0 ] = XPos;
         position[ 1 ] = YPos;
         nodeVector.add ( position . clone ( )  );
      }  // end of for ( int i = 0 ; i < vectorOfNodes.size ( ) ; i++ )
////      System.err.println ( "IN AddNodeAndLinks: vectorOfNodes.size ( ) = " +
////         vectorOfNodes.size () );
      // Add Links
      for ( int i = 0 ; i < vectorOfLinks.size () ; i ++ ) {
         ModelPhysical.Link link = vectorOfLinks.get ( i );
         GraphicalLink1 graphicalLink =
            new GraphicalLink1 ( link.sourceNodeNumber ,
            link.destinationNodeNumber , link.bitRateSourceToDestination ,
            link.interfaceType , link.bitErrorRate , link.transmissionDelay );
         linkVector.add ( graphicalLink );
      }  // end of for ( int i = 0 ; i < vectorOfNodes.size ( ) ; i++ )
      // Add Interfaces
      PositionInterfaces ( ) ;

   }  // end of InitializeVectors

   
   /**Computes the position of the Interfaces.*/
   private static void PositionInterfaces ( ) {
////System.err.println ("IN PositionInterfaces ( ) ") ; 
   interfaceVector . clear ( ) ;
       for ( int i = 0 ; i < vectorOfLinks.size () ; i ++ ) {
         ModelPhysical.Link link = vectorOfLinks.get ( i );
         int sourceNodeNumber = link.sourceNodeNumber;
         int destinationNodeNumber = link.destinationNodeNumber;
         ModelPhysical.Node node = vectorOfNodes.get ( sourceNodeNumber );
         position = nodeVector . get ( sourceNodeNumber );
////System.err.println ( " Node " + sourceNodeNumber + " at " 
////+ position [0] + " , " + position [1]  );          
         int startXPos = position[ 0 ] ;
         int startYPos = position[ 1 ] ;
 ////        node = vectorOfNodes.get ( destinationNodeNumber );
         position = nodeVector . get ( destinationNodeNumber  );
//// System.err.println ( " Node " + destinationNodeNumber + " at " 
////+ position [0] + " , " + position [1]  );         
         int endXPos = position[ 0 ] ;
         int endYPos = position[ 1 ] ;
         int diffX = endXPos - startXPos;
         int diffY = endYPos - startYPos;
         double length = java.lang.Math.sqrt ( diffX * diffX + diffY * diffY );
         double alpha = nodeRadius / length;
         int XPos = ( int ) ( startXPos + alpha * diffX );
         int YPos = ( int ) ( startYPos + alpha * diffY );
         position = new int [ 2 ] ; 
         position[ 0 ] = XPos;
         position[ 1 ] = YPos;
         interfaceVector.add ( position  );       
         XPos = ( int ) ( endXPos - alpha * diffX );
         YPos = ( int ) ( endYPos - alpha * diffY );
         position = new int [ 2 ] ; 
         position[ 0 ] = XPos;
         position[ 1 ] = YPos;
         interfaceVector.add ( position  );       
      }  // end of for ( int i = 0 ; i < vectorOfNodes.size ( ) ; i++ )     
   }  // end of PositionInterfaces ( )

   
   /**Paint the Nodes and Links*/
   public void paint ( Graphics g ) {
      super.paint ( g );
 ////System.out.println ("IN NetworkDisplay_RealTime paint (): isEventDispatchThread = " + javax.swing.SwingUtilities.isEventDispatchThread ()) ;      
      java.awt.Graphics2D g2d = ( java.awt.Graphics2D ) g;
      java.awt.Font font = g2d.getFont ();
      java.awt.FontMetrics fontMetrics = g2d.getFontMetrics ();
      String string;
      String spaces = "    ";
      String stringTR = "T" + spaces + "R";
      int widthInPixelsTR = fontMetrics.stringWidth ( stringTR );
      int widthInPixels;
      int heightInPixels = fontMetrics.getHeight ();
      // Add the links
      g2d.setColor ( Color.BLACK );
      g2d.setStroke ( new java.awt.BasicStroke ( ( float ) 5.0 ) );
      for ( int i = 0 ; i < vectorOfLinks.size () ; i ++ ) {
//// System.err.println ( "In paint 2 " ) ;
         ModelPhysical.Link link = vectorOfLinks.get ( i );
         int sourceNodeNumber = link.sourceNodeNumber;
         int destinationNodeNumber = link.destinationNodeNumber;
////         ModelPhysical.Node node = vectorOfNodes.get ( sourceNodeNumber );
         position = nodeVector.get ( sourceNodeNumber ); 
         int startXPos = position [ 0 ] ;
         int startYPos = position [ 1 ] ;
////         node = vectorOfNodes.get ( destinationNodeNumber );
          position = nodeVector.get ( destinationNodeNumber );         
         int endXPos = position [ 0 ] ;
         int endYPos = position [ 1 ] ;
         g2d.drawLine ( startXPos , startYPos , endXPos , endYPos );
      // Make the line thicker based on the slope
      }  // end of for ( int i = 0 ; i < vectorOfLinks.size () ; i ++ )
      // Draw Nodes
////      g2d.setColor ( Color.BLUE );
      g2d.setStroke ( new java.awt.BasicStroke ( ( float ) 1.0 ) );
      for ( int i = 0 ; i < vectorOfNodes.size () ; i ++ ) {
////System.err.println ( "In paint 1 " ) ;
         ModelPhysical.Node node = vectorOfNodes.get ( i );
          position = nodeVector.get ( i );          
         int XPos = position [ 0 ] ;
         int YPos = position [ 1 ] ;
         //System.err.println ("Drawing Node of radius " + nodeRadius ) ;
         g2d.setColor ( Color.BLUE );
         g2d.fillOval ( XPos - nodeRadius , YPos - nodeRadius , 2 * nodeRadius ,
            2 * nodeRadius );
         string = "Node " + i;
         widthInPixels = fontMetrics.stringWidth ( string );
         g2d.setColor ( Color.WHITE );
         g2d.drawString ( string , XPos - widthInPixels / 2 , YPos /*- heightInPixels /2*/ );
         string = new Integer ( node.nodeBuffer.size () ).toString ();
         widthInPixels = fontMetrics.stringWidth ( string );
         heightInPixels = fontMetrics.getHeight ();
         g2d.drawString ( string , XPos - widthInPixels / 2 , YPos +
            heightInPixels );
      }  // end of for ( int i = 0 ; i < vectorOfNodes.size ( ) ; i++ )

      // Draw the Interfaces
      g2d.setStroke ( new java.awt.BasicStroke ( ( float ) 1.0 ) );
      for ( int i = 0 ; i < vectorOfLinks.size () ; i ++ ) {
         position = interfaceVector.get ( 2 * i );
         XPos = position[ 0 ];
         YPos = position[ 1 ];
//// System.err.println ("DRAWING Interface " + ( 2 * i ) +  " at " 
//// + position [0] + " , " + position [1]  ) ;       
         g2d.setColor ( Color.YELLOW );
         g2d.fillOval ( XPos - interfaceRadius , YPos - interfaceRadius , 2 *
            interfaceRadius , 2 * interfaceRadius );
         g2d.setColor ( Color.BLACK );
         g2d.drawString ( stringTR , XPos - widthInPixelsTR / 2 , YPos );
         string = new Integer ( vectorOfInterfaces.get ( 2 * i ).transmitBuffer.
            size () ).toString () + spaces + new Integer ( vectorOfInterfaces.
            get ( 2 * i ).receiveBuffer.size () ).toString ();
         widthInPixels = fontMetrics.stringWidth ( string );
         g2d.drawString ( string , XPos - widthInPixels / 2 , YPos +
            heightInPixels );
         g2d.drawLine ( XPos , YPos - interfaceRadius , XPos , YPos +
            interfaceRadius );
         position = interfaceVector.get ( 2 * i + 1 );
         XPos = position[ 0 ];
         YPos = position[ 1 ];
////  System.err.println ("DRAWING Interface " + ( 2 * i + 1 ) +  " at " 
//// + position [0] + " , " + position [1]  ) ;          
         g2d.setColor ( Color.YELLOW );
         g2d.fillOval ( XPos - interfaceRadius , YPos - interfaceRadius , 2 *
            interfaceRadius , 2 * interfaceRadius );
         g2d.setColor ( Color.BLACK );
         g2d.drawString ( stringTR , XPos - widthInPixelsTR / 2 , YPos );
         string = new Integer (
            vectorOfInterfaces.get ( 2 * i + 1 ).transmitBuffer.size () ).
            toString () + spaces + new Integer ( vectorOfInterfaces.get (
            2 * i + 1 ).receiveBuffer.size () ).toString ();
         widthInPixels = fontMetrics.stringWidth ( string );
         g2d.drawString ( string , XPos - widthInPixels / 2 , YPos +
            heightInPixels );
         g2d.drawLine ( XPos , YPos - interfaceRadius , XPos , YPos +
            interfaceRadius );
      }  // end of for ( int i = 0 ; i < vectorOfNodes.size ( ) ; i++ )

   }  // end of method paint

   
   /**A private class to handle mouse clicks.  This class inherits
    * java.awt.event.MouseAdapter which implements the standard means of
    * handling mouse clicks.  this class overrides the methods specific
    * to this GUI.*/
   private static class MouseClickHandler extends java.awt.event.MouseAdapter {

      // Handle a mouse pressed
      public void mousePressed ( java.awt.event.MouseEvent event ) {
///         System.err.println ( " The mouse has been pressed." );
         RESET ();
         XPos = event.getX ();
         YPos = event.getY ();
         nodeWherePressed = FindNodeWherePressed ( XPos , YPos );
         if (event.isMetaDown () == true) {
            isRightButtonClicked = true;
         }  // end of if
         
 ////        linkWherePressed = FindLinkWherePressed ( XPos , YPos );
//// System.err.println ( " The mouse has been pressed\nENTERED DATA: XPos = " +
////          XPos + " YPos = " + YPos + " nodeWherePressed = " + nodeWherePressed ) ; 
      }  // end of mousePressed

      public void mouseReleased ( java.awt.event.MouseEvent event ) {
 ////         System.err.println ( "The mouse has been released." );
         // If the mouse was NOT dragged or the mouse dragging
         // did NOT start on a Node, return and do nothing
         if (isDraggingTakingPlace == true & nodeWherePressed != MINUS_ONE) {
            // Get the present position where the mouse was released
            XPos = event.getX ();
            YPos = event.getY ();
//// System.err.println ( "in mouseReleased: Before calling FindNodeWherePressed." );
            int nodeWhereReleased = FindNodeWherePressed ( XPos , YPos );
//// System.err.println ( "in mouseReleased: After calling FindNodeWherePressed." );
            //If the Node was dragged and released on free space
            // Move the Node
//// System.err.println ( "in mouseReleased: nodeWhereReleased = " + nodeWhereReleased
////    + " isRightButtonClicked = " + isRightButtonClicked );
            // Do not permit release over another Node
            if ( nodeWhereReleased == MINUS_ONE ) {
               // The Node is being moved
               position = new int[ 2 ];
               position[ 0 ] = XPos;
               position[ 1 ] = YPos;
               // Move the position of the Node to data
//// System.err.println ( " Setting Node " + nodeWherePressed + " to " + XPos + " , " + YPos  );
               nodeVector.setElementAt ( position  , nodeWherePressed );
               
for ( int i = 0 ; i < nodeVector.  size ( ) ; i ++ ) {
   position = nodeVector.get  ( i );
////System.err.println ( " Node " + i+ " at " + position [0] + " , " + position [1]  ); 
}               
               // UpdateGraphicalVariables the data in the Links attached to the Node
////System.err.println ( "In mouseReleased 1 " ) ;
//// System.err.println ( " Updating Links "  );
               for ( int i = 0 ; i < linkVector.size () ; i ++ ) {
////System.err.println ( "In mouseReleased 1 " ) ;
                  temporaryLink = linkVector.get ( i );
                  // Has the link position changed?
                  if ( temporaryLink.startNodeNumber == nodeWherePressed 
                     | temporaryLink.endNodeNumber == nodeWherePressed  ) { 
                  // UpdateGraphicalVariables he value of the denominator squared
                  temporaryLink.UpdateGraphicalVariables ();
                  }
               }  // end of for ( int i = 0 ; i < linkVector.size () ; i ++ )
            }  // end of if ( nodeWhereReleased == MINUS_ONE )
         // UpdateGraphicalVariables the Interface positions
         PositionInterfaces ( ) ;
         // And then repaint
         networkDisplay.repaint ();            
         }  // end of if (isDraggingTakingPlace == true & nodeWherePressed != MINUS_ONE)
         ////System.err.println ( "In mouseReleased before repaint." );
      ////System.err.println ( "In mouseReleased after repaint." );
      } // end of public void mouseReleased

      /**Finds a Node, if any, that covers position xPosIn, xPosIn.  The method
       * returns the <u>first</u> Node that is under the click, not all the
       * Nodes.  If no Node is found, the method returns a MINUS_ONE.*/
      public static int FindNodeWherePressed ( int XPosIn , int YPosIn ) {
         for ( int i = 0 ; i < nodeVector.size () ; i ++ ) {
////System.err.println ( "In FindNodeWherePressed  1 : i = " + i ) ;
            position = nodeVector.get ( i );
            int xDel = XPosIn - position[ 0];
            int yDel = YPosIn - position[ 1];
            // Is the click on this Node?
            if (xDel * xDel + yDel * yDel <= nodeRadius * nodeRadius) {
////               System.err.println ( "In FindNodeWherePressed   1 : i = " +
////                  i );
               return i;
            }  // end of if ( xDel * xDel + yDel * yDel <= nodeRadius * nodeRadius )
         }  // end of for ( int i = 0 ; i < nodeVector.size () ; i ++ )
         // There is no such Node
         return MINUS_ONE;
      }  // end of FindNodeWherePressed

   }  // end of private class MouseClickHandler

   
   /**A private class to handle mouse clicks.  This class inherits
    * java.awt.event.MouseAdapter which implements the standard means of
    * handling mouse clicks.  this class overrides the methods specific
    * to this GUI.*/
   private static class MouseMotionAdapter extends java.awt.event.MouseMotionAdapter {

      public void mouseDragged ( java.awt.event.MouseEvent event ) {
////System.err.println ( "In mouse is being dragged. "  );
         // If dragging has alread started, ignore the continuation
         // until the mouse is released
         isDraggingTakingPlace = true;
      }

   }  // end of private class MouseMotionAdapter

   /**Resets the mouse variables and booleans*/
   public static void RESET () {
      nodeWherePressed = nodeWhereReleased = MINUS_ONE;
////      linkWherePressed = MINUS_ONE;
////      interfaceWherePressed = MINUS_ONE;
      XPos = YPos = MINUS_ONE;
      isDraggingTakingPlace = false;
////      isRightButtonClicked = false;
      temporaryLink = null;
      position = null;
   }

   
   /**Creates a CommonCloseWindowOperation( ) for the topology
    * network window.  It will simply make the topology display
    * invisible and deletes any topology.
    * @version 1.100
    * @author dixonw*/
   private static class MyGraphicalWindowAdapter
      extends java.awt.event.WindowAdapter {

      public void windowClosing ( java.awt.event.WindowEvent e ) {
         networkDisplay.setVisible ( false );
         nodeVector.clear ();
         linkVector.clear ();
         interfaceVector.clear ();
      }  // end of windowClosing

   } // end of private class MyWindowAdapter

   
   /**Creates a Component Adapter to redraw the GUI when it is resized.*/
   private static class MyComponentAdapter
      extends java.awt.event.ComponentAdapter {
      // When the window is resized, repaint it.
      public void componentResized ( java.awt.event.ComponentEvent e ) {
         networkDisplay.repaint ();
      }  // end of method componentResized

   }  // end of class MyComponentAdapter

}  // end of class

