/* Generated by Together */
package GUIs;

import java.awt.*;
import java.lang.reflect.Field;
import javax.swing.*;
import javax.swing.border.*;

/**Creates a singleton instance of the GUIs for inputting all the java 
 * objects.  The java object is passed to the GUI which constructs the 
 * GUI by examining the fields in the object and returning JComponents
 * which the GUI displays.  When the enter button is pressed the 
 * ReadValueFromGUI() method for every field is called to save the 
 * value entered on the GUI.
 * *<p><b>Versions:</b>
 * <li><b>Version 1.101</b> of 20080726 removes the field
 * wholePanel since it seems to do nothing.  Also move may operations
 * to the static initializer to save time.</li>
 * @version 1.101
 * @author dixonw*/
public final class InputGUI extends StandardJFrame {

   /**The singleton instance of the GUIclass.*/
   private static final InputGUI inputGUI = new InputGUI ();

   /** The javaObject's Fields (attributes).*/
   private static Field[] dataObjectFields;

   /**The names of the javaObject's attributes.*/
   private static String[] attributeNames;

   /**Components for the GUI.*/
   private static JComponent[] jComponent;

   /**Text fields of the components.*/
   private static JTextField[] jTextField;

   /**The class name*/
   private static String className = null;

   /**The input class for display and editing*/
   private static GUIData.InputClassesBaseClass input = null;

   /**The call line parameters to invoke ReturnLoadedJComponent.  ReturnLoadedJComponent ( )
   requires no call line parameters, so this array is set to null*/
   private static java.lang.Class noCallLineParameters[] = null;

   /**Boolean that assures that all the entered values are correct*/
   private static boolean areAllEntriesCorrect = true;

   /**Container for the input GUI */
   private static java.awt.Container jFrameContent = inputGUI.getContentPane ();
   
   /**The "ENTER/UPDATE" button.*/
   private static javax.swing.JButton enterButton 
      = new javax.swing.JButton ( inputGUIButtonTitle );
   
   /**The gridlayout for the JPanel containing the title and the 
    * variable for each field in the input class.*/
   private static java.awt.GridLayout gridLayout 
      = new java.awt.GridLayout ( 2 , 1 ) ;
   
   /**The button JPanel.*/
   private static JPanel buttonPanel = new JPanel ();

   /**A private constructor to ensure that the GUI will be a singleton.*/
   private InputGUI () {
      super ();
   }

   
   // The static initializer
   static {
       // make a border for the buttons
      Border border = BorderFactory.createBevelBorder ( BevelBorder.RAISED );
      enterButton.setBackground ( standardBlueButtonColor );
      enterButton.setForeground ( standardButtonLetteringColor );
      enterButton.setFont ( standardButtonBoldFont );
      enterButton.setBorder ( border );
      enterButton.addActionListener ( new java.awt.event.ActionListener () {
         public void actionPerformed ( java.awt.event.ActionEvent e ) {
            UpdateJavaObjectAttributes ( );
            if (areAllEntriesCorrect == true) {
               inputGUI.setVisible ( false );
            }
            else { // The inputGUI will remain visible for data re-entry, 
               // therefore reset areAllEntriesCorrect so that the
               // inputGUI can close when the errors are corrected
               areAllEntriesCorrect = true;
            }  // end of else
         }  // end of actionPerformed
      } // After adding action listener
      ); // end of enterButton . addActionListener 
      buttonPanel.setLayout ( new FlowLayout () );
      buttonPanel.add ( enterButton );
      inputGUI.setResizable ( true );
   }
   
   
   /**Returns the one instance of an input GUI.  getinstance( ) will delete
    * all the components from the center panels and reconstruct the
    * new center panel.*/
   public static InputGUI getInstance ( GUIData.InputClassesBaseClass inputIn ) {
      input = inputIn;
      MakeClassNameandAttributesandAttributeNames ();
      inputGUI . setTitle ( GUIs.StringProcessorsforGUIs.MakeJFrameTitle ( 
      input . getClass ().getName () ) + " Input Window" );
      // Clear out the old components
      jFrameContent.removeAll ( ) ;
      // innerPanel is the panel for the list of fields to be entered
      JPanel innerPanel = new JPanel (  ) ;
      BoxLayout innerBoxlayout = new BoxLayout ( innerPanel , BoxLayout.PAGE_AXIS );
      jFrameContent.setLayout ( new java.awt.BorderLayout () );
      // Add the title to the inputGUI
      JLabel titleLabel = new JLabel (
         GUIs.StringProcessorsforGUIs.MakeJFrameTitle ( input.getClass ().
         getName () ) );
      // Center the title
      titleLabel.setHorizontalAlignment ( javax.swing.SwingConstants.CENTER );
      jFrameContent.add ( titleLabel , java.awt.BorderLayout.NORTH );
      innerPanel.setLayout ( innerBoxlayout );
      innerPanel.setFont ( jLabelsFont );
      innerPanel.setForeground ( jLabelsColor );
      JLabel label [ ] = new JLabel [ attributeNames.length ] ;
      jComponent = new JComponent[ attributeNames.length ];      
      for ( int j = 0 ; j < dataObjectFields.length ; j ++ ) {
         try {           
            java.lang.Class attributeClass = dataObjectFields[j].getType ();
            java.lang.reflect.Method method =
               attributeClass.getDeclaredMethod ( "ReturnLoadedJComponent" ,
               noCallLineParameters );
            jComponent[j] = ( JComponent ) method.invoke ( dataObjectFields[j].
               get ( input ) , ( java.lang.Object[] ) noCallLineParameters );
            jComponent[j].setBackground ( jComponentBackgroundColor );
         }
         catch ( Exception exception ) {
            Utility.err.println ( "ERROR IN GUIS.InputGUI.getInstance()" +
               "Object() throws an " + exception.getClass ().getName () +
               " in getting the " + j + "th attribute of object " );
         }  // end of catch
         label [ j ] = new JLabel ( attributeNames[j] 
            , javax.swing.SwingConstants.CENTER );
         label [ j ] . setForeground ( jLabelsColor );
         // If the jComponent is a checkbox
         if (jComponent[j] instanceof javax.swing.JCheckBox) {
            javax.swing.JCheckBox jCheckBox = new javax.swing.JCheckBox ( ) ;
            jCheckBox = ( javax.swing.JCheckBox ) jComponent[j];           
            // Put the label on the same line as the checkbox
            jCheckBox.setText ( label [ j ] .getText () );
            innerPanel.add ( jCheckBox );
         }
         // Otherwise put the label above the jComponent
         else {
            JPanel pairPanel = new JPanel ( gridLayout ) ;
            pairPanel.add ( label [ j ]   );
            pairPanel.add ( jComponent[j ] ); 
            innerPanel . add ( pairPanel ) ;
         }  // end of else
      }  // end of int j = 0 ; j < attributeNames . length ; j++  
      // Now put the innerPanel inside a jScrollPane
      JScrollPane jScrollPane = new JScrollPane ( innerPanel ,
         ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED ,
        ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED );
      jFrameContent.add ( jScrollPane , java.awt.BorderLayout.CENTER );    
      // Add in the JButtons
      jFrameContent.add ( enterButton , java.awt.BorderLayout.SOUTH );
      jFrameContent.validate ( ) ;
      // Add the button panel to the display panel
      inputGUI.pack ();
      // Set the upper left corner of the GUI to a specific location
      inputGUI.setLocation ( XLocationOfInputGUI , YLocationOfInputGUI );
      // Get the dimension of the inputGUI
      // Make sure that the GUI is not too tall to be useful
      inputGUI.setSize (
         java.lang.Math.max ( ( int ) inputGUI.getSize ().getWidth () ,
         minimumOpeningWidthOfInputGUI ) , java.lang.Math.min ( ( int ) inputGUI.getSize ().
         getHeight () , maximumOpeningHeightOfInputGUI ) );
      inputGUI.setVisible ( true );
      return inputGUI ;
   }  // end of getInstance ( )


   /**Creates a array of Strings containing the fields' names.
    * It changes "_" to " " in the field name, and it converts the first character
    * in the field name and the first character after a "_" to an uppercase letter.*/
   private static void MakeClassNameandAttributesandAttributeNames () {
      // Get the javaObject's Fields
      dataObjectFields = input.getClass ().getDeclaredFields ();
      attributeNames = new String[ dataObjectFields.length ];
      for ( int i = 0 ; i < dataObjectFields.length ; i ++ ) {
         attributeNames[i] = GUIs.StringProcessorsforGUIs.
            MakeDataTitleForInputGUI ( dataObjectFields[i].getName () );
      } // end of for i = 0 ; i < dataObjectFields . length

   }  // end of MakeClassNameandAttributesandAttributeNames( )


   /**Calls the method "ReadValueFromGUI" for each field in the inputGUI.  This causes
    * the field to read its value from the input GUI.  If an error occurs in reading the field
    * then areAllEntriesCorrect is set to false, and the inputGUI will not close. */
   private static void UpdateJavaObjectAttributes () {
      // The Class of the object being parsed
      java.lang.Class attributeClass = null;
      for ( int j = 0 ; j < dataObjectFields.length ; j ++ ) {
         try {
            attributeClass = dataObjectFields[j].getType ();
            java.lang.reflect.Method method =
               attributeClass.getDeclaredMethod ( "ReadValueFromGUI" ,
               noCallLineParameters );
            method.invoke ( dataObjectFields[j].get ( input ) ,
               ( java.lang.Object[] ) noCallLineParameters );
         }
         catch ( Exception e ) {
            java.lang.reflect.Field field = dataObjectFields[j];
            String fieldName = field.getName ();
            Utility.err.println ( "ERROR IN updating JavaObjectsGUI.getInstance(): " 
               + "Object() throws an " + e.getClass ().getName () 
               + "\nin getting " + fieldName + ", the " + j 
               + "th attribute of class " + input.getClass ().getName () 
               + "\nThe exception message is " + e.getMessage () );
            // Set the entries variable so that the window will not close
            areAllEntriesCorrect = false;
         }  // end of catch

      }  // end of for ( int j = 0 ; j < dataObjectFields.length ; j++ )
      // Now call the SetInputData ( ) method for the input class to update the corresponding
      // variables in the model.

      java.lang.Class inputClass = input.getClass ();
      java.lang.reflect.Method method = null;
      try {
         // Get the UpdateInputData ( ) method
         method = inputClass.getDeclaredMethod ( "UpdateInputData" ,
            noCallLineParameters );
         // Invoke the UpdateInputData ( ) method
         method.invoke ( input );
      }
      catch ( Exception e ) {
         Utility.err.println ( "ERROR IN updating JavaObjectsGUI.getInstance()" 
            + "Object() throws an " + e.getClass ().getName () 
            + "\nIN invoking the UpdateInputData method for the input class " 
            + input.getClass (). getName () + "\nThe exception message is " 
            + e.getMessage () );
      }  // end of catch 

   }  // end of UpdateJavaObjectAttributes()


}  // end of class InputGUI
