/* Generated by Together */

package GUIs;

import javax.swing.*;
////import Utility.Output ;

/**
 * StandardJFrame defines all the standard characteristics of the JFrames to 
 * be used by all the GUIs: All GUIs in this application inherit from 
 * class StandardJFrame.
 * <P>StandardJFrame defines the:
 * <ul>
 * <li>references types for all the GUIs
 * <li>standard colors,
 * <li>standard fonts,
 * <li>standard GUI components (two buttons, a JtextArea, and three JPanels)
 * <li>standard components for the input (each GUI has a JPanel, JLabel, and 
 * JTextField for every column in the database), and 
 * <li>three Containers for NORTH, CENTRAL, and SOUTH positions in the border 
 * layouts.
 * </ul>
 * @version 1.100
 * @author dixonw*/
public class StandardJFrame extends JFrame implements GUIConstants.General {
    
/** Default constructor.  It set the standard look and feel and then sets
* the window listener to MyWindowAdapter, which defines the standard responses
* to window events.*/
    public StandardJFrame() {
       // Set the look and feel
       setLookAndFeel( ) ;
       // Do nothing when closing the window
       this . setBackground( GUIConstants.ColorsForGUIs.jComponentBackgroundColor ) ;
    }

 /**
    * Sets the Look and Feel using the LOOK_AND_FEEL_CONSTANT from
    * interface Constants.General.LOOK_AND_FEEL_CONSTANT
    * <P>The LOOK_AND_FEEL_CONSTANT chooses the look and feel of all the GUIs
    * <ul>
    * <li>set LOOK_AND_FEEL_CONSTANT = 0 for "Metal"
    * <li>set LOOK_AND_FEEL_CONSTANT = 1 for "Openlook"
    * <li>set LOOK_AND_FEEL_CONSTANT = 2 for "Windows"</LISTING></P>
    * </ul>
    */
    protected void setLookAndFeel() {
          // Set Look and Feel using the LOOK_AND_FEEL_CONSTANT from
          // interface Constants.General.
          looks = javax.swing.UIManager.getInstalledLookAndFeels();
          try {
             javax.swing.UIManager.setLookAndFeel( 
                    looks [ LOOK_AND_FEEL_CONSTANT ].getClassName() );
             javax.swing.SwingUtilities.updateComponentTreeUI( this );
              }
             // process problems changing look and feel
				catch ( Exception exception ) {
                    Utility.err.println ("ERROR IN method StandardJFrame."
                    + "setLookAndFeel().  It has thrown a "
                    + exception . getClass ( ) . getName ( ) + "exception." ) ;
                    exception.printStackTrace();
				}
    }  // end of setLookAndFeel()


/**An array of look and feel information.*/
   private UIManager.LookAndFeelInfo[] looks;

}  // end of StandardJFrame
