/*
 * ListOfEvents.java
 *
 * Created on February 9, 2007, 12:07 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package ModelDES;

/**
 * Subclasses a LinkedList to create a list of ModelDatas.Events, all of which have
 * occurred at the same time.  The ListOfEvents includes a timeOfEventsList which is
 * initialized inn the constructor when the
 * first ModelDatas.ModelEventsBaseClass is put on the ListOfEvents.
 * 
 * 
 * 
 * @author dixonw
 * @version 1.202
 * @modified JMP 12Nov2011 for TPC/HDLC
 */
public class ListOfEvents  implements GUIConstants.General
{
   
   /**Time of this list of events*/
   private long timeOfEventsList ;
   
   /**The linked list*/
   private java.util.LinkedList<ModelEvents.ModelEventsBaseClass> linkedList = null ;
   
   
   /**Creates a new instance of ListOfEvents.*/
   public ListOfEvents ( ModelEvents.ModelEventsBaseClass event )
   {
      timeOfEventsList = event . getEventStartTime ( ) ;
      linkedList = new java.util.LinkedList<ModelEvents.ModelEventsBaseClass> ( ) ;      
      linkedList . add (  event ) ;
   }  // end of ListOfEvents
   
   
   /**Creates a new instance of ListOfEvents with timeOfEventsList = -1 and
    *no events on the ListOfEvents.  This is used ONLY to initialize the
    * discrete event simulator with one event.  Otherwise it is necessary to
    * test whether the diescrete evnet simulator is empty.*/
   public ListOfEvents (  )
   {
      timeOfEventsList = MINUS_ONE ;
      linkedList = new java.util.LinkedList<ModelEvents.ModelEventsBaseClass> ( ) ;
   }  // end of ListOfEvents
   
   
   /**Adds an event to the eventsList*/
   public void add (ModelEvents.ModelEventsBaseClass event)
   {
      if (timeOfEventsList == event . getEventStartTime () )
      {
         linkedList . add (  event ) ;
      }  // end of if (timeOfEventsList == event . getEventStartTime() )
      else
      {
         Utility.err.println ( "ERROR in ModelData.TimeEventsList.add list time:"+
            timeOfEventsList+" adding "+event .toString ( ) ) ;
      }  // end of else
   }  // endof add
   
   
   /**Retrieves and removes the head (first element) of this events list.  It returns null
   if the list is empty.*/
   public ModelEvents.ModelEventsBaseClass getHead ( )
   {
      return  linkedList . poll ( );
   }  // end of getHead
   
   
   /**Removes an event from the events list.  It return either true or false if the
  event is found or not.*/
   public boolean deleteEvent ( int eventSequenceNumber)
   {
      boolean found = false ;
      java.util.ListIterator<ModelEvents.ModelEventsBaseClass> iterator
         = linkedList . listIterator ( ) ;
      while ( iterator . hasNext ( ) )
      {
         ModelEvents.ModelEventsBaseClass event =  iterator . next ( ) ;
         if (  event  . getEventSequenceNumber ( ) == eventSequenceNumber )
         {  // Remove the event just found
            iterator . remove ( ) ;
            found = true ;
            break ;
         }
      }  // end of while
      return found ;
   } // end of deleteEvent
   
   
   /**A getter for the timeOfEventsList*/
   public long getTimeOfEventsList ( )
   {
      return timeOfEventsList ;
   }
   
   
   /**A getter for the list size */
   public int getListSize ( )
   {
      return linkedList . size ( ) ;
   }
   
   
   /**Returns a boolean indicating whether the list is empty*/
   public boolean isEmpty ( )
   {
      if ( linkedList . size ( ) == 0 )
      {
         return true ;
      }
      else
      { return false ; }
   }  // end of isEmpty
   
   
   /**Returns the linked list.*/
   public java.util.LinkedList<ModelEvents.ModelEventsBaseClass> getLinkedList ( )
   {
      return linkedList ;
   }
   
   
   /**The toString() method.*/
   public String toString ( )
   {
      java.lang.StringBuilder stringBuilder
         = new java.lang.StringBuilder ( "Eventlist occurred at time "
         + timeOfEventsList +  " and contains "
         + linkedList . size ( ) + " events as follows:\n" ) ;
      java.util.ListIterator iterator
         = linkedList . listIterator ( ) ;
      while ( iterator . hasNext ( ) )
      {
         ModelEvents.ModelEventsBaseClass event 
            = ( ModelEvents.ModelEventsBaseClass ) iterator . next ( ) ;
         stringBuilder .append ( event .toString ( ) + CARRIAGE_RETURN )   ;
      }
      return new String ( stringBuilder ) ;
   }  // ent od toString ()   
   
   /**The toString() method.*/
   public String toStringSequenceNumbers ( )
   {
      java.lang.StringBuilder stringBuilder
         = new java.lang.StringBuilder ( "Eventlist occurred at time "
         + timeOfEventsList +  " and contains "
         + linkedList . size ( ) + " events as follows:\n" ) ;
      java.util.ListIterator iterator
         = linkedList . listIterator ( ) ;
      while ( iterator . hasNext ( ) )
      {
         ModelEvents.ModelEventsBaseClass event 
            = ( ModelEvents.ModelEventsBaseClass ) iterator . next ( ) ;
         stringBuilder .append ( event .toStringSequenceNumber () + CARRIAGE_RETURN )   ;
      }
      return new String ( stringBuilder ) ;
   }  // ent od toString ()
   
   /**Gets the ith Event on the ListOfEvents .*/
   public ModelEvents.ModelEventsBaseClass get ( int i )
   {
      return linkedList . get ( i ) ;
   }  // end of get
   
}  // end of ListOfEvents

