/*
 * GlobalVariables.java
 *
 * Created on February 9, 2007, 9:53 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package ModelData;

/**Contains the global variables for the model.  This class was not
 * implemented as an interface because most of these fields are
 * are changed during execution.
 *
 * @version 1.100
 * @author dixonw*/
public class GlobalVariables  extends ModelDataBaseClass {
////public interface GlobalVariables {   
     
    /**Author(s) name(s)*/
    public static String authorsNames = ""  ;
    
    /**Maximum time ticks*/
    public static long maximumDESTicks = 10000000 ;
    
    /**Interactive mode of operation.  In interactive mode, the model
     *stops at the ends of each print statement inside the method Interact.
     *  See Utility.Interactive.*/
    public static boolean interactiveModeOfOperation = false ;
        
    /**A form of interactive mode of operation.  If pauseAtPrints == true,
     * the simulation stops after every print to await either continue or
     * exit.  See Utility.Interactive.*/
    public static boolean pauseAtPrints = false ;
    
    /**Model simulation time in "ticks."*/
    public static long simulationTime = 0 ; 
  
    /**Number of time ticks per second.  For a 100 nanoseconds period
    *there are 10000000.0 time ticks per second.*/
    public static final double timeTicksPerSecond = 10000000.0 ;
  
    /**An enumeration defining the mode of transmission, UDP or TCP*/
    public static enum transmissionProtocols { UDP , TCP } ;
  
    /**An enumeration defining the type of network.*/
    public static enum networkTypes { Undefined, Router_Network , Ethernet_Bus , Token_Ring } ;
    
    /**The type of network: Router_Network, Ethernet_Bus, or Token_Ring.*/
    public static networkTypes  networkType  = networkTypes . Undefined ; 

    /**An enumeration defining the possible types of interfaces.*/
    public static enum interfaceTypes { Ethernet, HDLC , TokenRing  } ;  

   /**Boolean telling whether the checksum are to be
    * evaluated at the receiver.*/
    public static boolean verifyChecksumsAtReceiver = true ;

   /**Boolean telling whether the checksum are to be
    * evaluated at the receiver.*/
    public static boolean printReceiverErrors = true ; 
    
    /**Boolean telling whether the model is paused.*/
    public static boolean modelPaused = false ;
    
    /**Boolean telling whether the model is operating one step at a time.*/
    public static boolean singleStepOperation = false ;

    // The followings are BZ's declarations
    public static enum tl_send_state{closed, syn_sent, tl_sending, close_wait};
    
    public static enum tl_receive_state{listening, receiving};

    public static int TL_MAX_BUFFER_SEGS = 40; // the size of arrayOfTransmittedPacketInformation, defined in TCPState (BZ)

    public static int SEGMENT_HEADER_OFFSET = 20; // segment header has 20 bytes

    public static int MESSAGE_HEADER_OFFSET = 6;

    // End of BZ's declaration

    //public static int SYN_TIMEOUT_PERIOD = 100;

    /** Creates a new instance of GlobalVariables.  Converts the input variables 
     * in inputData to a name that can be easily used in the model.  Passing is
     done in GUIDatas.Global_Variables_UpdateInputData( )*/
    public GlobalVariables( ) { }  // end of constructor
}
