/*
 * GlobalVariables.java
 *
 * Created on February 9, 2007, 9:53 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package ModelData;

/**Contains the global variables for the message load generator.
 *The values can be updated 
 *using the LOAD GENERATOR VARAIBLES GUI.  The variables are updated in
 *class GUIDatas.Load_Generator_Variables.
 *
  * @version 1.100
 * @author dixonw*/
public class LoadGeneratorVariables  extends ModelDataBaseClass 
        implements GUIConstants . General {

   /**An enumeration defining the distribution of the length of the
   *message.*/
    public static enum possibleMessageLengthDistributions { Fixed , Exponential } ;
  
    /**The distribution of the length of the message.*/
    public static possibleMessageLengthDistributions messageLengthDistribution
       = possibleMessageLengthDistributions . Fixed ; 
  
   /**The mean length of the message in bytes.  The length includes the
    * IP header ( 20 bytes) and the UDP header ( 8 bytes).  Therefore, the
    * messages length cannot be less than 28 bytes.*/
    public static int messageMeanLength = 500 ;
    
   /**The rate at which messages are being generated in messages per second.*/
    public static double messageGenerationRate = 200 ;    
    
    /**The source node number.  This uses a long, 64 bits, 
     * because the Java byte is a signed byte. */
    public static int sourceNodeNumber = 0 ; 
    
    /**The destination node.  This uses a long, 64 bits, 
     * because the Java byte is a signed byte. */
     public static int destinationNodeNumber = 1 ; 
     
 
     /**This boolean is set in GUIDatas.Load_Generator_Variables.UpdateInputData ( ).
      * It signifies that the user has entered load data and that a generate load
      * event has been put into the discrete event simulator.
      * <p>If the user opens the load generator variables GUI, and decides 
      * NOT to create a load by closing the window without pushing the ENTER/UPDATE
      * button, no GenerateMessageLoad event will be put into the discrete 
      * event simulator.  This boolean is initialized to false and it is set to 
      * true in GUIDatas.Load_Generator_Variables.UpdateInputData ( ) ONLY when 
      * the ENTER/UPDATE button is pushed.
      <p>The boolean is also use in GUIActions.GetLoadGenerationVariablesAction
      to ensure that ONLY ONE load generator is created.  Otherwise a user might
      open the GENERATOR VARIABLES GUI several times thinking he was 
      * only updating the data when in fact he was creating 
      * multiple load generators.*/
     public static boolean hasGUIButtonBeenPushed = false ;
     
     
    /** Creates a new instance of GlobalVariables.  Passes the input variables from
    *inputData to a name that can be easily used in the model.*/
    public LoadGeneratorVariables() { }  // end of constructor

    
}
