/*
 * EthernetState.java
 *
 * Created on June 8, 2007, 8:04 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package ModelDataLink;

import Utility.JNWBitSet ;

/**Defines the state of the Ethernet interface either between two nodes
 *running as point-to-point interfaces or on an Ethernet bus.
 *
 * @version 1.100
 * @author dixonw*/
public class EthernetState extends InterfaceBaseClass {
    
 
/**Time that the start of another transmission from another Ethernet interface
 * is received at this interface.  The Ethernet interface cannot start frame 
 * transmission between startReceiveOtherEthernetFrame and stopReceiveOtherEthernetFrame.*/
 public long startReceiveEthernetFrame ;
 
 
 /**Time that the end of another transmission from another Ethernet interface
  * is received at this interface.  The Ethernet interface cannot start frame 
  * transmission between startReceiveOtherEthernetFrame and stopReceiveOtherEthernetFrame.*/
 public long stopReceiveEthernetFrame ;
 
 /**A collision has been detected on the Ethernet bus.*/
 public static boolean collisionHasOccurredOnBus ;
 
 
 /**The maximum number of transmission attempts.*/
 public static final int maximumNumberOfTransmissionAttempts = 16 ;
 

 /**The size of Ethernet slits in ticks.  It's 51.2 microseconds.*/
 public static final int ethernetSlotSizeInTicks = 512 ;
 
 
    /** Creates a new instance of EthernetState */
    public EthernetState( ) {
        super ( ) ;
        startReceiveEthernetFrame = 0 ;
        stopReceiveEthernetFrame = 0 ;
        collisionHasOccurredOnBus = false ;
    }  // end of constructor
    
}
