/*
 * ReceivePhysicalFrameIntoInterface.java
 *
 * Created on July 11, 2007, 3:59 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */
package ModelEvents;

import ModelData.GlobalVariables.transmissionProtocols;

/**Receives the Ethernet physical frame into the interface card.
 *
 * @version 1.100
 * @author dixonw*/
public class ReceivePhysicalFrameIntoEthernetBusInterface extends ModelEventsBaseClass
   implements ModelConstants.Node , GUIConstants.General {

   /**The received frame*/
   Utility.JNWBitSet frameReceived;

   /**The source inferface number. */
   int sourceInterfaceNumber;

   /**The destination inferface number. */
   int destinationInterfaceNumber;

   /**The number of the event which sent the Ethernet Frame.*/
   int sendEthernetFrameEventNumber;

   /**The interface.*/
   ModelDataLink.InterfaceBaseClass interfaceCard = null;

      /**The Ethernet Bus*/
   ModelPhysical.EthernetBus ethernetBus
      = ( ModelPhysical.EthernetBus ) vectorOfLinks.get (0);
   
   /** Creates a new instance of ReceivePhysicalFrameIntoInterface */
   public ReceivePhysicalFrameIntoEthernetBusInterface ( long eventTime , Utility.JNWBitSet frameReceived , int sourceInterfaceNumber ////      , int destinationInterfaceNumber , int transmissionAttemptNumber) {      
      , int destinationInterfaceNumber , int sendEthernetFrameEventNumber ) {
      super ( eventTime );
      this.frameReceived = frameReceived;
      this.sourceInterfaceNumber = sourceInterfaceNumber;
      this.destinationInterfaceNumber = destinationInterfaceNumber;
      this.sendEthernetFrameEventNumber = sendEthernetFrameEventNumber;
   }

   /**Executes the receive.  This accepts the frame from the Ethernet bus.*/
   public void ExecuteEvent () {
////..
 ////     System.out.println ( "IN ReceivePhysicalFrameIntoEthernetInterface for "
 ////        + " sendEthernetFrameEventNumber = " + sendEthernetFrameEventNumber + " at event time " 
 ////        + eventStartTime );
////..      ModelPhysical.EthernetBus ethernetBus 
////..         = ( ModelPhysical.EthernetBus ) vectorOfLinks.get ( 0 );
/*      System.out.println ( "\nIN ReceivePhysicalFrameIntoEthernetInterface " 
         + "\n     ethernetBus.collisionHasOccurred = " + ethernetBus.collisionHasOccurred
         + " ethernetBus.busInUse = " + ethernetBus.busInUse ); 
 */
      ethernetBus . busInUse = false ;  
////..
////      System.out.println ( "IN ReceivePhysicalFrameIntoEthernetInterface " 
////         + "\n     ethernetBus.collisionHasOccurred = " + ethernetBus.collisionHasOccurred
////         + " ethernetBus.busInUse = " + ethernetBus.busInUse );       
      // If a collision has occurred
      if (ethernetBus . collisionHasOccurred ) {
         // Bus will remain silent until the noise blanking period is over
         ethernetBus . collisionHasOccurred = false;
////      System.out.println ( "IN ReceivePhysicalFrameIntoEthernetInterface after resetting collisionHasOccurred" 
////         + "\n     ethernetBus.collisionHasOccurred = " + ethernetBus.collisionHasOccurred
////         + " ethernetBus.busInUse = " + ethernetBus.busInUse );
      // Return.  The frame will be automatically retransmitted
 ////     System.out.println ( "IN ReceivePhysicalFrameIntoEthernetInterface after resetting collisionHasOccurred" 
////         + "\nsendEthernetFrameEventNumber = " + sendEthernetFrameEventNumber + " will be retransmitted." );      
         return ;
      }

      // Should the checksum be verified?  If so is it true?
      if (ModelData.GlobalVariables.verifyChecksumsAtReceiver == false 
         || ( ModelData.GlobalVariables.verifyChecksumsAtReceiver == true 
         && ModelDataLink.InterfaceBaseClass.verifyAtReceiver ( frameReceived ) == true )) 
      {
         // Add the frame to the receive buffer
         vectorOfInterfaces.get ( destinationInterfaceNumber ).receiveBuffer.add ( frameReceived );
         // Get the node for the interface buffer
         eventStopTime = eventStartTime 
            + ( long ) ( frameReceived.getJNWLength () * globalVariables.timeTicksPerSecond 
            / ( 1000.0 * ethernetBus . bitRateEthernetBus ) );
         // Create the next event
         // the node number and the interface number are identical
         new MovePacketFromInterfaceToNodeBuffer ( eventStopTime , destinationInterfaceNumber    );
         // Delete the retransmit Event since the transmission was successful
         ModelDES.DiscreteEventSimulator.getInstance ().deleteEvent ( sendEthernetFrameEventNumber );
      }  // end of if ( ModelData.GlobalVariables.verifyChecksumsAtReceiver == false...
      else {  // Simply drop the frame and do NOT create a new Event
         if (ModelData.GlobalVariables.printReceiverErrors == true) {
            Utility.err.println ( "ERROR: In receiving frame into interface " + interfaceNumber );
         }  // end of if (ModelData.GlobalVariables.printReceiverErrors == true) 
      }  //  end of else
         // Update the global time
         UpdateGlobalSimultationTime ( eventStopTime );
   }  // end of Execute
}
