/*
 * RoutePacketAtNodeOrProcessAtDestination.java
 *
 * Created on July 6, 2007, 2:23 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package ModelEvents;

import static ModelTransport . UDPUtilities . * ;
import static ModelTransport . IPUtilities . * ;
import Utility.*;

/**Routes the packet at the node.  Read the destination address from
 *the IP packet, looks up the interface in the routing table, and
 *places the packet into the transmit buffer for the correct
 *interface.
  *<p><b>Versions:</b>
 *<li><b>Version 1.200</b> of 20081019 adds the default case to switch
 * statement in ExecuteEvent ( ).</li>
 *<li><b>Version 1.201</b> of 20081121 cleans up a lot of junk in code.</li>
 * @version 1.202
 * @author dixonw
 * @modified JMP 21Oct2011 and BZ April 2010
 */
public class RoutePacketAtNodeOrProcessAtDestination extends ModelEventsBaseClass
   implements ModelConstants.Node
{
   /**The IPPacket being routed.*/
   Utility.JNWBitSet IPPacket = null  ;
 
   /**
    * Creates a new RoutePacketAtNodeOrProcessAtDestination
    */
   public RoutePacketAtNodeOrProcessAtDestination ( 
              long eventStartTime ,
              int nodeNumber ,
              JNWBitSet packetToRoute )
   {
      super ( eventStartTime ) ;
      thisNodeNumber = nodeNumber ;
      IPPacket = packetToRoute;
   }
   
   /**A singleton vector containing all the Nodes*/
   static ModelData.JNWSingletonVectorOfNodes<ModelPhysical.Node> vectorOfNodes =
      ModelData.JNWSingletonVectorOfNodes.getInstance ();
   
   /**Routes the BitSet from the node transmit buffer to the transmit buffer
    * of the interface .*/
   public void ExecuteEvent ( )
   {  
      // Get this node
      ModelPhysical.Node node  = vectorOfNodes . get ( thisNodeNumber ) ;
      // Update the node time
      eventStartTime = node . UpdateNodeTime ( eventStartTime ) ;
      //Look up interface number in routing table
      int interfaceNumber = Integer . MIN_VALUE ;

      // Get the IP packet
      if(IPPacket == null)
      {   // Error: Transmit buffer empty, no packet to transmit (BZ)
          err . println  ( "ERROR IN ModelEvents"
           + ".RoutePacketsAtNode.Execute(): The node buffer "
           + "for node " + thisNodeNumber + " is unexpectedly empty." ) ;
      }  // end of if ( ( IPPacket = ( Utility.JNWBitSet ) node . nodeBuffer . poll (  ) )
      else
      {
         // get the destination node number
         destinationNodeNumber = ( int ) ModelTransport.IPUtilities . GetDestinationAddressFromIPHeader ( IPPacket ) ;
         // uncomment next 2 lines to print packet forwarding as it occurs
         //Utility.out.println("ROUTE FROM:"+thisNodeNumber+" TO:"+
         //    destinationNodeNumber);//+"\n"+IPPacket);
         // Invalid destination (BZ)
         if (destinationNodeNumber > vectorOfNodes.size())
         {
           Utility.out.println("ERROR IN ModelEvents"
           + ".RoutePacketsAtNode.Execute(): Destination node " + destinationNodeNumber
           + " exceeds number of nodes in network." ) ;
         }
         // If this is the destination,
         if ( destinationNodeNumber == thisNodeNumber )
         { // So process the packet here
           ProcessMessageAtThisDestination (  ) ;
         }  // end of if ( destinationNodeNumber == thisNodeNumber )
         else
         {  //Look up interface number in routing table
//// THE INTERFACE NUMBER IS INITIALIZED TO -1
//// SO THAT IT WILL BE INITIALIZED TO SOMETHING AS PART OF EXERCISE JWAN2
            interfaceNumber= -1 ;
//// AS PART OF EXERCISE JNW2, THE STUDENT IS TO COMPLETE
//// COMPLETE THE LINE OF CODE THAT READS THE CORRECT INTERFACE
//// NUMBER FROM THE ROUTING TABLE FOR PACKET FORWARDING
//// BY REPLACING -1 WITH THE CORRECT EXPRESSION

            interfaceNumber = -1;
            interfaceNumber = node . routingTable [ destinationNodeNumber ] ; //mustremove
            
////STUDENTS SHOULD ADD ONE LINE BEFORE HERE
////STUDENTS SHOULD ADD ONE LINE BEFORE HERE
////Utility.out.println ( "ON Node " + thisNodeNumber
////   + " routing packet to node " + destinationNodeNumber ) ;
////YOU MAY WISH TO PRINT THE LINES ABOVE

            // NOTE: each interface has its own buffer (BZ)
            // Get the interface and add the IPPacket to the buffer
            // Fill the transmit buffer at the outgoing interface with packets (BZ)
            vectorOfInterfaces . get ( interfaceNumber ) . transmitBuffer
                . add ( IPPacket ) ;
            eventStopTime = eventStartTime + timeToRoutePacketInTicks
               + timeToMovePacketFromNodeBufferToInterfaceBufferInTicks ;
            // Update the node time to the end of this Event
            node . UpdateNodeTime ( eventStopTime  ) ;
            // Update the global simulation time to the maximum of the 
            // existing simulation time and the eventStopTime
            UpdateGlobalSimultationTime ( eventStopTime ) ;
            // Schedule event at DLC layer
            new ModelEvents . SendFrameFromInterface ( eventStopTime
               , interfaceNumber , IPPacket, false) ;
         }  // end of else
      }  // end of else

      return ; 
   }   // end of Execute
   
   
   /**Process.*/
   public void ProcessMessageAtThisDestination ( )
   {    
      // First check the IP packet for errors if appropriate
      // Should the checksum be verified?  If so is it true?
      boolean processThisPacket =
          !ModelData.GlobalVariables.verifyChecksumsAtReceiver;
      if(ModelData.GlobalVariables.verifyChecksumsAtReceiver) 
          processThisPacket =
              ModelTransport.IPUtilities.VerifyIPHeaderChecksum ( IPPacket );
      if(processThisPacket)
      {
         // No error in IP header
         // Process differently for UDP and TCP
         boolean errorPacketReceived = false;// BZ
         SWITCH: switch ( GetProtocolFromIPHeader ( IPPacket ) )
         {  // process UDP or TDCP message
            case UDP :
               //Is there an error in the UDP packet?
               if ( ModelData.GlobalVariables.verifyChecksumsAtReceiver == true
                  && ModelTransport . UDPUtilities
                  . VerifyUDPXORFromIPPacket ( IPPacket ) == false )
               {
                  if ( ModelData.GlobalVariables.printReceiverErrors == true )
                  {
                     Utility.err.println ("CHECKSUM ERROR: In receiving UDP packet on node "
                        + thisNodeNumber ) ;
                  }  // end of if ( ModelDatas . GlobalVariables . printReceiverErrors == true )
                  break SWITCH ;
               }  // end of if ( ModelDatas . GlobalVariables . verifyChecksumsAtReceiver == true
               Utility.JNWBitSet eMailAsJNWBitSet
                  = GetDataFromUDP_IPPacket ( IPPacket ) ;
               eMailAsJNWBitSet . removeNullCharactersAtEnd ( ) ;
               String eMail = eMailAsJNWBitSet . convertJNWBitSetToString ( ) ;
               out . print (  "\n\n E-Mail UDP Message RECEIVED at node "
                  + thisNodeNumber + " is:\n"  + eMail + DOUBLE_CARRIAGE_RETURN ) ;
               break ;
               
            case TCP :  // Process TCP message by passing to TCPDestinationBuffer               
               //Is there an error in the TCP packet?
               if ( ModelData.GlobalVariables.verifyChecksumsAtReceiver )
                  if ( !ModelTransport . TCPUtilities
                  . VerifyTCPXORFromIPPacket ( IPPacket ) )
               {
                  // Do not verify checksum for SYN, SYN-ACK, FIN, FIN-ACK, or ACK. The following if{} is added by BZ
                  if(!ModelTransport.TCPUtilities.IsPacketAnSYNMessage(IPPacket)    &&
                     !ModelTransport.TCPUtilities.IsPacketAnSYNACKMessage(IPPacket) &&
                     !ModelTransport.TCPUtilities.IsPacketAnFINMessage(IPPacket)    &&
                     !ModelTransport.TCPUtilities.IsPacketAnFINACKMessage(IPPacket) &&
                     !ModelTransport.TCPUtilities.IsPacketAnACKMessage(IPPacket) ) {

                      if ( ModelData.GlobalVariables.printReceiverErrors )
                      {
                         Utility.err.println ("CHECKSUM ERROR: In receiving TCP packet on node "
                            + thisNodeNumber ) ;
                      }  // end of if ( ModelData . GlobalVariables . printReceiverErrors == true )
                      errorPacketReceived = true;// BZ
                      //break SWITCH  ;             BZ
                  }
               }  // end of if ( ModelData . GlobalVariables . verifyChecksumsAtReceiver == true
               
               ModelPhysical . Node destinationNode = vectorOfNodes . get ( thisNodeNumber ) ;

               sourceNodeNumber = ( int ) GetSourceAddressFromIPHeader ( IPPacket ) ;

               // Get the TCP connection
               ModelTransport . TCPConnection tcpConnection
                  = destinationNode . tcpConnection;

               // Since TCP connection is not yet established while received a SYN packet, 
               // this node needs to passively establish a connection (i.e. accept connection) (BZ)
               if ( tcpConnection == null )
               {
                   err.println  ( "ERROR in ModelEvents.RoutePacketAtNodeOrProcessAtDestination."
                      + "ExecuteEvent( ) TCP connection between destination node "
                      + thisNodeNumber + " and source node "
                      +  sourceNodeNumber + " does not exist." ) ;
                   return ;
               }


               //  Have the TCP connection NAK or process that message
               tcpConnection . ProcessReceivedTCPPacket (
                   eventStartTime ,
                   IPPacket,
                   errorPacketReceived  ) ;
               break ;

            default:
               err.println  ( "ERROR in ModelEvents.RoutePacketAtNodeOrProcessAtDestination.ExecuteEvent"
                  + " IP packet protocol, " + GetProtocolFromIPHeader ( IPPacket ) + " not recognized" ) ;
         }  // end of switch ( GetProtocolFromIPHeader ( IPPacket ) )
      }  // end of if ( ModelData.GlobalVariables.verifyChecksumsAtReceiver == false... 
      else  // 444
      {  // Else simply drop the frame and do NOT create a new Event
         if ( ModelData.GlobalVariables.printReceiverErrors )
         {
            Utility.err.println ("CHECKSUM ERROR: In processing IP packet at node " 
               + thisNodeNumber ) ;
         }  // end of if ( ModelData.GlobalVariables.printReceiverErrors == true )
      }  // end of else 444
      return ; 
   }  // end of Execute
   
}  // end of class RoutePacketAtNodeOrProcessAtDestination
