/*
 * Link.java
 *
 * Created on December 20, 2006, 2:26 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package ModelPhysical;

/**Creates an Ethernet bus for use by students. 
 *
 * @version 1.100
 * @author dixonw*/
public class EthernetBus_Student extends ModelPhysical.Link implements GUIConstants . General {
    
    /**The singleton vector containing all the nodes*/
    ModelData.JNWSingletonVectorOfNodes<ModelPhysical.Node> vectorOfNodes
            = ModelData.JNWSingletonVectorOfNodes.getInstance ( ) ;
    
    /**The singleton vector containing all the links*/
    ModelData.JNWSingletonVectorOfLinks<ModelPhysical.Link> vectorOfLinks
            = ModelData.JNWSingletonVectorOfLinks.getInstance ( ) ;
    
    /**The singleton vector containing all the links*/
    ModelData.JNWSingletonVectorOfInterfaces<ModelDataLink.InterfaceBaseClass>
            vectorOfInterfaces
            = ModelData.JNWSingletonVectorOfInterfaces.getInstance( ) ;
     
    /**Data rate in kbps on the Ethernet bus*/
    public int bitRateEthernetBus ;
    
    /** Number of bits passed through this Ethernet bus*/
    public long numberOfBitspassed = 0 ;

    /** Number of it errors on this Ethernet bus.*/
    public long numberOfBitErrors = 0 ;
    
    /** Bit error rate for transmissions on this Ethernet bus*/
    public float bitErrorRate ;

    /** Transmission delay on the Ethernet bus in microseconds between one i and node j */
    public float [ ] [ ] transmissionDelay ;

    /** Transmission delay on the Ethernet bus in ticks between one i and node j */
    public static long [ ] [ ] transmissionDelayinTicks ;

    /** Transmission delay on the Ethernet bus in ticks between the source and the destination */
    public long linkTransmissionDelayinTicks ;
    
    /**The number of simultaneous transmissions on the bus.  Used to detect collisions*/
    public int numberOfSimultaneousTransmissions = 0 ;
    
    /**Has a collision occurred?*/
    public boolean collisionHasOccurred = false ;
////    Utility.JNWRandom randomNumberGenerator = Utility.JNWRandom.getInstance ( ) ;
    /**Is therre a transmission on the Ethernet bus*/
    public boolean ethernetBusInUse = false ;
    /** Creates a new instance of an Ethernet Bus.  
     * An Ethernet bus is entered using 
     * 
     * First the constructor accesses the 
     * links to compute the time dealys between the different The port
     * numbers are not initialized here.  The port numbers are computed in 
     * MainGUI_Actions.ReadTopologyFileAction.CreateArray ( ).  The link also 
     * add the interface cards to the singletonVectorOfInterfaces. */
    public EthernetBus_Student(/*int sourceNodeSequentialNumber, int destinationNodeSequentialNumber, int dataRate 
       , float bitErrorRate , float transmissionDelay 
       , ModelDatas.Enumerations.networkType linkType*/ ) {
        //First compute the delay times between the different nodes 
        ComputeTimeDelaysBetweenNodesOnEthernetBus ( )   ;
        // Remove any nodes, links, or interfaces from the Vectors.  This could happen if the user 
        // opens a second topology file.  Also reset the static numbers so that the links
        // and interfaces are numbered from 0
        // Remove all the Links
        vectorOfLinks . removeAllElements( );
        // Remove all the interfaces
        vectorOfInterfaces . removeAllElements( );
        // Add this Ethernet bus to the vector of Links
        vectorOfLinks .add ( this ) ;
        // Update the roouting tables and the vector of links 
        // and the vector of interfaces for each node.
        for (int i = 0 ; i < vectorOfNodes.size() ; i++ ) {
            ModelPhysical . Node node = vectorOfNodes. get ( i ) ;
            // First remove all the links for this Node
            node . vectorOfLinksForThisNode . removeAllElements() ;
            // Add this Ethernet bus to the vector of Links for this Node 
            node . vectorOfLinksForThisNode .add ( this ) ;
            // Now create the routing table so that all the packets are
            // routed throught the one interface attached to the node
            node . routingTable = new int [ vectorOfNodes.size() ] ;           
               for (int j = 0 ; j < vectorOfNodes.size() ; j++ ) {
                  // All the packets are routed to the single interface
                  node . routingTable [ j ] = i ;                
               }  // end of for (int j = 0 ; j < vectorOfNodes.size() ; j++ )       
            // First remove all the interfaces for this Node
            node .vectorOfInterfacesForThisNode . removeAllElements() ;
            // Add the Ethernet interface card back
            ModelDataLink.Ethernet ethernetInterface 
               = new ModelDataLink.Ethernet ( i ) ;
            vectorOfInterfaces.add ( ethernetInterface ) ;
            // First remove all the links for this Node
            node . vectorOfInterfacesForThisNode .add ( ethernetInterface ) ;
        }  // end of for (int i = 0 ; i < vectorOfNodes.size() ; i++ ) 
        numberOfSimultaneousTransmissions  = 0 ;
        collisionHasOccurred = false ;
        ethernetBusInUse = false ;        
    }  // end of  EthernetBus constructor
    
    
  /**Computes the delay times between the nodes on an Ethernet bus.*/
  public void ComputeTimeDelaysBetweenNodesOnEthernetBus ( ) {
      //FOR THE STUDENT TO FILL OUT
      //FOR THE STUDENT TO FILL OUT
      //FOR THE STUDENT TO FILL OUT
      //FOR THE STUDENT TO FILL OUT
  }  // end of ComputeTimeDelaysBetweenNodesOnEthernetBus
   
 
/** This toString method returns the Link as a String with each object in the vector returned as 
* separate lines.*/
    public String toString ( ) {
          return " Ethernet bus has rate = " 
              + this . bitRateEthernetBus + " with return rate " 
              + " with bit error rate " + this . bitErrorRate + " and transmission delay "
              + this . transmissionDelay  +  " microseconds with interfaces\n" ; 
    }  // end of method toString  

    
    /**Sets the arrival times for the frame at all the interface cards.  When the frame
     of length frameLength is transmitted at time eventTime from interface sourceInterface
     * the frame starts to arrive at startReceiveEthernetFrame and stop arriving 
     * at stopReceiveEthernetFrame.  StartReceiveEthernetFrame and stopReceiveEthernetFrame
     * are computed for every Ethernet cord on the bus.. */
    public void SetArrivalTimesAtAllInterfacesOnEthernetBus ( long eventTime
       , int frameLength
       , int sourceInterface ) {
         long tranmissionLength =  frameLength / bitRateSourceToDestination;     
         for ( int i = 0 ; i < vectorOfNodes.size ( ) ; i++ ) {
            ModelDataLink.Ethernet ethernetCard 
               = ( ModelDataLink.Ethernet ) singletonVectorOfInterfaces . get ( i ) ; 
               //Get the time delay time
            long delay = transmissionDelayinTicks [ sourceInterface ] [ i ] ;
            ethernetCard . startReceiveEthernetFrame = eventTime + delay ;
            ethernetCard . stopReceiveEthernetFrame = eventTime + delay + tranmissionLength ;      
        }  // end of for ( int i = 0 ; i < vectorOfNodes.size ( ) ; i++ )       
    }  // end of SetArrivalTimesAtAllInterfaces ( )
    
          
}  // end of class
