/*
 * StartJNW.java
 *
 * Created on December 20, 2006, 8:07 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

/**Network Workbench is a discrete time simulation of a communications
 *network. A detailed description of Network Workbench is contained
 *in "Understanding Internet Protocols Through Hands on Programming," J
 *Mark Pullen, John Wiley & Sons, 2000.  This version of Network
 *Workbench is written in Java to provide a clearer presentation
 *of the networking.</p>
 *<p>
 * /-------------------------------------------------------------------*
 * |             Network Workbench Version 4.2                         |
 * |     Copyright (c) 1997-2001 by J. Mark Pullen                     |
 * |      George Mason University, Fairfax, Virginia                   |
 * |                                                                   |
 * |  Permission to use, copy, modify, and distribute this             |
 * |  software and its documentation for academic purposes is hereby   |
 * |  granted without fee, provided that the above copyright notice    |
 * |  and this permission appear in all copies and in supporting       |
 * |  documentation, and that the name of George Mason University      |
 * |  not be used in advertising or publicity pertaining to            |
 * |  distribution of the software without specific, written prior     |
 * |  permission. GMU makes no representations about the suitability   |
 * |  of this software for any purposes.  It is provided "AS IS"       |
 * |  without express or implied warranties.  All risk associated      |
 * |  with use of this software is expressly assumed by the user.      |
 * |  GMU does not give its permission to sell this software, or       |
 * |  include it within commercial products, without separate          |
 * |  written agreement.                                               |
 * -------------------------------------------------------------------/
 *
 *Users are requested to send comments and improvements on the Workbench
 *to mpullen@gmu.edu.
 * </p>
 *<p>StartJNW is the main class of the simulation.  For some
 *strange, unknown reason I found that importing import GUIConstants.*
 *or implementing GUIConstants.General causes the JavaDoc tool to abort.
 *Therefore, I had to use explicit carriage returns, "\n" and a declaration
 *for intFormatTwoDigits.
 * *<p><b>Versions:</b>
 * <li><b>Version 1.200</b> of 2008???? starts the MainGUI using 
 * javax.swing.SwingUtilities.invokeLater.</li>
 *
 * @version 1.202
 * @author dixonw
 * @modified JMP 28Oct11 for HDLC
 * @see <a href="http://java.sun.com/developer/technicalArticles/javase/swingworker/">Using SwingWorker</a>
 */
public class StartJNW
{
   /**Creates a new instance of StartJNW, which starts the model
    * at the MainGUI.*/
   public StartJNW ()
   {  // See the reference for an explanation of this code
      javax.swing.SwingUtilities.invokeLater(new Runnable() {
    public void run() {
       GUIs.MainGUI maiGUI = new GUIs.MainGUI ( ); }
    } );
   }  // end of public StartJNW ()

   /**The main starting point for the simulation.<p>The "standard" output 
    * stream will be redirected if a path name is passed as the first call
    * line parameter.  The "standard" error output stream will be 
    * redirected if a path name is passed as the second call line parameter.
    * Pass the name as, for example, C:\Output.txt.  Do 
    * <b>NOT</b> enclose the name in quotation marks such as "C:\Output.txt".
    *<p>You can redirect the error output stream without redirecting the
    * output stream by entering an invalid file name, such as OUTPUT, 
    * for the output file name.
    *@param args the command line arguments
    */
   public static void main (String[] args)
   {  // Added only because importing GUIConstants.General causes the JavaDoc
      // tool to abort.
      // Has a new output file location been passed as a parameter?
      // Reset the error output stream.
      if ( args.length > 1 )
      {
         String errorFilePath = null ;
         try
         {
            errorFilePath =  args [ 1 ]  ;
            java.lang.System.setErr ( new java.io.PrintStream (
               new java.io.File ( errorFilePath ) ) ) ;
         }  // end of try
         catch ( java.lang.Exception exception )
         {
            Utility.err.println  ("ERROR in Main.Main (): Exception "
               + exception . getClass ( ) . getName ( ) + " thrown in trying"
               + " to redirect errors to file " + errorFilePath ) ;
         }  // end of catch
      }  // end of if ( args.length > 1 )
      if ( args.length > 0)
      {
         String outputFilePath =  null ;
         try
         {
            outputFilePath =  args [ 0 ]  ;
            java.lang.System.setOut ( new java.io.PrintStream (
               new java.io.File ( outputFilePath ) ) ) ;
         }  // end of try
         catch ( java.lang.Exception exception )
         {
            Utility.err.println  ("ERROR in Main.Main (): Exception "
               + exception . getClass ( ) . getName ( ) + " thrown in trying"
               + " to redirect output to file " + outputFilePath ) ;
         }  // end of catch
         String errorFilePath =  null ;
      }  // end of if ( args.length > 0)
      // Output time 
      Utility.out.println  ( "\n  STARTING Java Network Workbench Version "
        + GUIConstants . General. versionNumber + " "
        + ( new java.util.Date ( ) ) .toString ( ) + "\n") ;
      // StartJNW the simulation
      StartJNW  networkWorkbench = new StartJNW ( ) ;
   }  // end of public static void main (String[] args)

}  // end of class StartJNW()
