/*
 * out.java
 *
 * Created on February 20, 2007, 6:41 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */
package Utility;

/**
 * Provides methods to write messages.  Messages always are written
 * to the center panel of the MainGUI.  The user can choose to have 
 * the messages written to System.out.  The user sets boolean
 * sendOutputToStandardOutput to choose that option.
 * 
 * <p><b>VERSIONS:</b>
 * <li><b>Version 1.100</b> The print, err, and Interact() methods are not working
 * correctly.  print and err are causing the screen to "blink" while the
 * main thread is performing the calculations.  Read the description of the
 * method OutTEST for a further description of the problem and the attempted,
 * but ultimately futile, solutions.</li>
 * <li><b>Version 1.101</b> 20080801 Fixed the "blinking" error.</li>
 * <li><b>Version 1.200</b> 20080801 Changed jTextOutputPane . append ( string );
 * to jTextOutputPane.appendColored(string , java.awt.Color.BLACK);  If making multiple
 * runs and the last data printed was colored other than BLACK the output from this
 * method will be colored.</li>
 * <li><b>Version 1.201</b> 20081027 Added call to method Utility.Interactive.Interact;
 * to method print ( ).</li>
 
 * 
 * @author dixonw
 * @version 1.201
 * @see <a href="http://www.java-tips.org/java-se-tips/javax.swing/how-to-add-colored-text-to-the-document.html">Colored Textoutt</a>
 */
public class out {

   /** Allows access to the singleton of the output data.  This is the jTextArea*/
   static GUIData.JNWSingletonJTextPane jTextOutputPane =
      GUIData.JNWSingletonJTextPane.getInstance ();

   /**Boolean telling whether to print output sent to the Main GUI central
    *panel also to the standard output.*/
   private static boolean sendOutputToStandardOutput = true;

   /**The input String.*/
   private static String inputString;

   /**Creates a new instance of out.*/
   public out () {
   }

   /**Writes to the center panel of the Main GUI.  If 
    * sendOutputToStandardOutput is true, the output is also sent to 
    * the standard output.  See the JavaDoc for
    *StartNetworkWorkbench.Main for directions to redirect the standard 
    * output.*/
   public static void print ( String string ) {
      jTextOutputPane.appendColored(string , java.awt.Color.BLACK);
      if ( sendOutputToStandardOutput == true ) {
         System.out.print ( string );
      }  // end of if
   }  // end of public static void print

   /**Add a carraige return to a String before printing it in print().*/
   public static void println ( String string ) {
      print ( string + GUIConstants.General.CARRIAGE_RETURN );
   }  // end of public static void println

   /** FOR TESTING ONLY.*/
   public static void main_For_Testing_Only2 ( String[] args ) {
      System.err.println ( "IN PRINT" );
      out test = new out ();
      System.err.println ( "after tester" );
      System.exit ( 0 );
      // StartJNW the simulation
      GUIs.MainGUI networkWorkbench = new GUIs.MainGUI ();

      out print = new out ();
      String string = "NOW IS THE TIME FOR ALL GOOD MEN TO COME" +
         " TO THE AID OF THEIR COUNTRY.\n";
      string = string + string;
      for ( int i = 0 ; i < 1000 ; i ++ ) {
         String stringInt = new Integer ( i ).toString ();
         System.out.println ( " i = " + stringInt );
         ////print.OutTEST ( stringInt + "    \n" );
         for ( int j = 0 ; j < 32 ; j ++ ) {
         ////   print.OutTEST ( string );
         }
      }
   }  // end of public static void main_For_Testing_Only2
 


   /** FOR TESTING ONLY.*/
   public static void main_Testing_Only ( String[] args ) {
      GUIs.MainGUI maiGUI = new GUIs.MainGUI ();
      Utility.JNWBitSet unstuffedDataBits = new Utility.JNWBitSet ();
      Utility.JNWBitSet bitstuffedResult = new Utility.JNWBitSet ();
      getFonts ();

      javax.swing.text.StyledDocument styledDocument = jTextOutputPane.
         getStyledDocument ();


      javax.swing.text.SimpleAttributeSet attr =
         new javax.swing.text.SimpleAttributeSet ();
      java.awt.Font fontOld = styledDocument.getFont ( attr );
      System.out.println ( "Old font = " + fontOld.getFontName () );
      javax.swing.text.StyleConstants.setFontFamily ( attr , "Monospaced.plain" );
      javax.swing.text.StyleContext styleContext =
         new javax.swing.text.StyleContext ();
      // Read input data
      String inputString = "Hello good people!";
      // Convert input data to JNWBitSet
      unstuffedDataBits.setJNWBitSetToString ( inputString );
      String printString = unstuffedDataBits.toString ();
      printString =
         "01001000 01100101 01001000    0101 01101100\n         01101111 00100000 01100111 01101111\n01101100 01101111 00100000 01100111 01101111";
      ////printString = "01001000 01100101 01001000 01100101 01101100\n         01101111 00100000 01100111 01101111\n01101100 01101111 00100000 01100111 01101111" ;
      // print input
      jTextOutputPane.append ( "\nYour original email message is :\n" +
         printString + "\n\nwhich gives the bit set:\n" + printString );
      System.out.println ( "\nYour original email message is :\n" + printString +
         "\n\nwhich gives the bit set:\n" + printString );
   }  // end of public static void main_Testing_Only

   // Get font list
   private static void getFonts () {
      java.awt.GraphicsEnvironment env = java.awt.GraphicsEnvironment.
         getLocalGraphicsEnvironment ();
      java.awt.Font[] fonts = env.getAllFonts ();
      java.util.Vector fontlist = new java.util.Vector ();
      for ( int i = 0 ; i < fonts.length ; i ++ ) {
         java.awt.Font font = fonts[i];
         System.out.println ( " fontNames = " + fonts[i].getFontName () );
      }  // end of for ( int i = 0 ; i < fonts.length ; i ++ )  
   }  // end of private static void getFonts ()
   
   
   }  // end of class out
  